// Copyright 2011 Google Inc. All Rights Reserved.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Automatically generated from ../../net/instaweb/rewriter/add_instrumentation.js

namespace net_instaweb {

const char* JS_add_instrumentation =
    "/*\n * Copyright 2012 Google Inc.\n *\n * Licensed under the Ap"
    "ache License, Version 2.0 (the \"License\");\n * you may not us"
    "e this file except in compliance with the License.\n * You ma"
    "y obtain a copy of the License at\n *\n *      http://www.apac"
    "he.org/licenses/LICENSE-2.0\n *\n * Unless required by applica"
    "ble law or agreed to in writing, software\n * distributed und"
    "er the License is distributed on an \"AS IS\" BASIS,\n * WITHOU"
    "T WARRANTIES OR CONDITIONS OF ANY KIND, either express or im"
    "plied.\n * See the License for the specific language governin"
    "g permissions and\n * limitations under the License.\n */\n\n/**"
    "\n * @fileoverview Code for beaconing client page load time b"
    "ack to the server.\n * This javascript is part of the AddInst"
    "rumentationFilter.\n *\n * @author jud@google.com (Jud Porter)"
    "\n */\n\n// Exporting functions using quoted attributes to prev"
    "ent js compiler from\n// renaming them.\n// See http://code.go"
    "ogle.com/closure/compiler/docs/api-tutorial3.html#dangers\nwi"
    "ndow[\'pagespeed\'] = window[\'pagespeed\'] || {};\nvar pagespeed"
    " = window[\'pagespeed\'];\n\n/**\n * @constructor\n * @param {stri"
    "ng} beaconUrlPrefix The prefix portion of the beacon url.\n *"
    " @param {string} event Event to trigger on, either \'load\' or"
    " \'beforeunload\'.\n * @param {string} headerFetchTime Time to "
    "fetch header.\n * @param {string} timeToFirstByte Time to fir"
    "st byte at server.\n * @param {string} originFetchTime Time t"
    "o fetch origin.\n * @param {string} experimentId Id of curren"
    "t experiment.\n * @param {string} htmlUrl Url of the page the"
    " beacon is being inserted on.\n */\npagespeed.AddInstrumentati"
    "on = function(beaconUrlPrefix, event, headerFetchTime,\n     "
    "                                   timeToFirstByte, originFe"
    "tchTime,\n                                        experimentI"
    "d, htmlUrl) {\n  this.beaconUrlPrefix_ = beaconUrlPrefix;\n  t"
    "his.event_ = event;\n  this.headerFetchTime_ = headerFetchTim"
    "e;\n  this.timeToFirstByte_ = timeToFirstByte;\n  this.originF"
    "etchTime_ = originFetchTime;\n  this.experimentId_ = experime"
    "ntId;\n  this.htmlUrl_ = htmlUrl;\n\n  /**\n   * @type {string} "
    "Generated beacon url (created purely for ease of webdriver\n "
    "  *     testing.\n    */\n  this.beaconUrl = \'\';\n};\n\npagespeed"
    "[\'beaconUrl\'] = pagespeed.beaconUrl;\n\n/**\n * Create beacon U"
    "RL and send request to server.\n */\npagespeed.AddInstrumentat"
    "ion.prototype.sendBeacon = function() {\n  var url = this.bea"
    "conUrlPrefix_;\n\n  var oldStartTime = window[\'mod_pagespeed_s"
    "tart\'];\n  var currentTime = Number(new Date());\n  var tradit"
    "ionalPLT = (currentTime - oldStartTime);\n\n  // Handle a beac"
    "on url that already has query params.\n  url += (url.indexOf("
    "\'?\') == -1) ? \'?\' : \'&\';\n  url += \'ets=\';\n  url += (this.eve"
    "nt_ == \'load\') ? \'load:\' : \'unload:\';\n  url += traditionalPL"
    "T;\n\n  // We use navigation timing api for getting accurate s"
    "tart time. This api is\n  // available in Internet Explorer 9"
    "+, Google Chrome 6+ and Firefox 7+.\n  // If not present, we "
    "set the start time to when the rendering started.\n  // TODO("
    "satyanarayana): Remove the oldStartTime usages once\n  // dev"
    "console code has been updated to use the new \"rload\" param v"
    "alue.\n\n  if (this.event_ == \'beforeunload\' && window[\'mod_pa"
    "gespeed_loaded\']) {\n    return;\n  }\n\n  url += \'&r\' + this.ev"
    "ent_ + \'=\';\n  if (window[\'performance\']) {\n    var timingApi"
    " = window[\'performance\'][\'timing\'];\n    var navStartTime = t"
    "imingApi[\'navigationStart\'];\n    url += (timingApi[this.even"
    "t_ + \'EventStart\'] - navStartTime);\n    url += \'&nav=\' + (ti"
    "mingApi[\'fetchStart\'] - navStartTime);\n    url += \'&dns=\' + "
    "(\n        timingApi[\'domainLookupEnd\'] - timingApi[\'domainLo"
    "okupStart\']);\n    url += \'&connect=\' + (\n        timingApi[\'"
    "connectEnd\'] - timingApi[\'connectStart\']);\n    url += \'&req_"
    "start=\' + (timingApi[\'requestStart\'] - navStartTime);\n    ur"
    "l += \'&ttfb=\' + (\n        timingApi[\'responseStart\'] - timin"
    "gApi[\'requestStart\']);\n    url += \'&dwld=\' + (\n        timin"
    "gApi[\'responseEnd\'] - timingApi[\'responseStart\']);\n    url +"
    "= \'&dom_c=\' + (timingApi[\'domContentLoadedEventStart\'] - nav"
    "StartTime);\n\n    if (window[\'performance\'][\'navigation\']) {\n"
    "      url += \'&nt=\' + window[\'performance\'][\'navigation\'][\'t"
    "ype\'];\n    }\n  } else {\n   url += traditionalPLT;\n  }\n\n  url"
    " += (window.parent != window) ? \'&ifr=1\' : \'&ifr=0\';\n  if (t"
    "his.event_ == \'load\') {\n    window[\'mod_pagespeed_loaded\'] ="
    " true;\n    var numPrefetchedResources =\n        window[\'mod_"
    "pagespeed_num_resources_prefetched\'];\n    if (numPrefetchedR"
    "esources) {\n      url += \'&nrp=\' + numPrefetchedResources;\n "
    "   }\n    var prefetchStartTime = window[\'mod_pagespeed_prefe"
    "tch_start\'];\n    if (prefetchStartTime) {\n      url += \'&htm"
    "lAt=\' + (oldStartTime - prefetchStartTime);\n    }\n  }\n\n  if "
    "(pagespeed[\'panelLoader\']) {\n    var bcsi = pagespeed[\'panel"
    "Loader\'][\'getCsiTimings\']()[\'time\'];\n    url += \'&b_cdr=\' + "
    "bcsi[\'CRITICAL_DATA_RECEIVED\'] +\n           \'&b_cii=\' + bcsi"
    "[\'CRITICAL_IMAGES_INLINED\'] +\n           \'&b_cilrl=\' + bcsi["
    "\'CRITICAL_IMAGES_LOW_RES_LOADED\'] +\n           \'&b_cihrl=\' +"
    " bcsi[\'CRITICAL_IMAGES_HIGH_RES_LOADED\'] +\n           \'&b_nc"
    "dl=\' + bcsi[\'NON_CACHEABLE_DATA_LOADED\'] +\n           \'&b_nc"
    "l=\' + bcsi[\'NON_CRITICAL_LOADED\'];\n    var bci = pagespeed[\'"
    "panelLoader\'][\'getCriticalImagesInfo\']();\n    url += \'&b_nci"
    "i=\' + bci[\'NUM_CRITICAL_IMAGES_INLINED\'] +\n           \'&b_nc"
    "ini=\' + bci[\'NUM_CRITICAL_IMAGES_NOT_INLINED\'];\n  }\n  if (pa"
    "gespeed[\'criticalCss\']) {\n    var cc = pagespeed[\'criticalCs"
    "s\'];\n    url += \'&ccis=\' + cc[\'total_critical_inlined_size\']"
    " +\n           \'&cces=\' + cc[\'total_original_external_size\'] "
    "+\n           \'&ccos=\' + cc[\'total_overhead_size\'] +\n        "
    "   \'&ccrl=\' + cc[\'num_replaced_links\'] +\n           \'&ccul=\'"
    " + cc[\'num_unreplaced_links\'];\n  }\n  if (this.headerFetchTim"
    "e_ != \'\') {\n    url += \'&hft=\' + this.headerFetchTime_;\n  }\n"
    "  if (this.timeToFirstByte_ != \'\') {\n    url += \'&s_ttfb=\' +"
    " this.timeToFirstByte_;\n  }\n  if (this.originFetchTime_ != \'"
    "\') {\n    url += \'&ft=\' + this.originFetchTime_;\n  }\n  if (th"
    "is.experimentId_ != \'\') {\n    url += \'&exptid=\' + this.exper"
    "imentId_;\n  }\n  url += \'&url=\' + encodeURIComponent(this.htm"
    "lUrl_);\n\n  pagespeed[\'beaconUrl\'] = url;\n  new Image().src ="
    " url;\n};\n\n/**\n * Initialize instrumentation beacon.\n * @para"
    "m {string} beaconUrl Url of beacon.\n * @param {string} event"
    " Event to trigger on, either \'load\' or \'beforeunload\'.\n * @p"
    "aram {string} headerFetchTime Time to fetch header.\n * @para"
    "m {string} timeToFirstByte Time to first byte at server.\n * "
    "@param {string} originFetchTime Time to fetch origin.\n * @pa"
    "ram {string} experimentId Id of current experiment.\n * @para"
    "m {string} htmlUrl Url of the page the beacon is being inser"
    "ted on.\n */\npagespeed.addInstrumentationInit = function(beac"
    "onUrl, event, headerFetchTime,\n                             "
    "               timeToFirstByte, originFetchTime,\n           "
    "                                 experimentId, htmlUrl) {\n\n "
    " var temp = new pagespeed.AddInstrumentation(beaconUrl, even"
    "t, headerFetchTime,\n                                        "
    "      timeToFirstByte, originFetchTime,\n                    "
    "                          experimentId, htmlUrl);\n  if (wind"
    "ow.addEventListener) {\n    window.addEventListener(event, fu"
    "nction() { temp.sendBeacon() }, false);\n  } else {\n    windo"
    "w.attachEvent(\'on\' + event, function() { temp.sendBeacon() }"
    ");\n  }\n\n};\n\npagespeed[\'addInstrumentationInit\'] = pagespeed."
    "addInstrumentationInit;\n";

}  // namespace net_instaweb
