// Copyright 2011 Google Inc. All Rights Reserved.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Automatically generated from ../../net/instaweb/rewriter/client_domain_rewriter.js

namespace net_instaweb {

const char* JS_client_domain_rewriter =
    "/*\n * Copyright 2012 Google Inc.\n *\n * Licensed under the Ap"
    "ache License, Version 2.0 (the \"License\");\n * you may not us"
    "e this file except in compliance with the License.\n * You ma"
    "y obtain a copy of the License at\n *\n *      http://www.apac"
    "he.org/licenses/LICENSE-2.0\n *\n * Unless required by applica"
    "ble law or agreed to in writing, software\n * distributed und"
    "er the License is distributed on an \"AS IS\" BASIS,\n * WITHOU"
    "T WARRANTIES OR CONDITIONS OF ANY KIND, either express or im"
    "plied.\n * See the License for the specific language governin"
    "g permissions and\n * limitations under the License.\n */\n\n/**"
    "\n * @fileoverview Rewrites url domains on the client side. C"
    "licks and enter key\n * presses get intercepted. If the targe"
    "t url domain is a part of the mapped\n * domains, the target "
    "url domain gets rewritten.\n *\n * @author rahulbansal@google."
    "com (Rahul Bansal)\n */\n\nvar ENTER_KEY_CODE = 13;\n\n// Exporti"
    "ng functions using quoted attributes to prevent Closure Comp"
    "iler from\n// renaming them.\n// See http://code.google.com/cl"
    "osure/compiler/docs/api-tutorial3.html#dangers\nwindow[\'pages"
    "peed\'] = window[\'pagespeed\'] || {};\nvar pagespeed = window[\'"
    "pagespeed\'];\n\n/**\n * @constructor\n * @param {string} mappedD"
    "omainNames for which the url is to be rewritten.\n */\npagespe"
    "ed.ClientDomainRewriter = function(mappedDomainNames) {\n  /*"
    "\n   * @private\n   */\n  this.mappedDomainNames_ = mappedDomai"
    "nNames;\n};\n\n/**\n * Listener for events on anchor tags. Since"
    " we are listening at the body,\n * checks if the event is for"
    " an anchor. Also checks that if a keypress\n * resulted in th"
    "is event, it should have been due to pressing enter.\n * Proc"
    "esses the event only when these conditions are met.\n * @para"
    "m {Object} event which triggered this listener.\n */\npagespee"
    "d.ClientDomainRewriter.prototype.anchorListener = function(e"
    "vent) {\n  // We are interested only in ENTER on a LINK keypr"
    "ess events\n  // IE has window.event instead of event.\n  // T"
    "ODO(rahulbansal): Fix the keyup, keydown handling.\n  event ="
    " event || window.event;\n  if (event.type == \'keypress\' && ev"
    "ent.keyCode != ENTER_KEY_CODE) {\n    return;\n  }\n\n  for (var"
    " target = event.target; target != null; target = target.pare"
    "ntNode) {\n    if (target.tagName == \'A\') {\n      this.proces"
    "sEvent(target.href, event);\n      return;\n    }\n  }\n};\n\n/**\n"
    " * Adds anchor listeners to the body.\n */\npagespeed.ClientDo"
    "mainRewriter.prototype.addEventListeners = function() {\n  va"
    "r me = this;\n  // TODO(rahulbansal): This could potentially "
    "override existing event\n  // listeners. Fix that.\n  document"
    ".body.onclick = function(event) { me.anchorListener(event); "
    "};\n  document.body.onkeypress = function(event) { me.anchorL"
    "istener(event); };\n};\n\n/**\n * If url should be rewritten, se"
    "ts window.location to the rewritten url and\n * prevents defa"
    "ult event propagation.\n * @param {string} url for which the "
    "event is triggered.\n * @param {Object} event to be processed"
    ".\n */\npagespeed.ClientDomainRewriter.prototype.processEvent "
    "= function(url, event) {\n  for (var i = 0; i < this.mappedDo"
    "mainNames_.length; i++) {\n    if (url.indexOf(this.mappedDom"
    "ainNames_[i]) == 0) {\n      window.location = window.locatio"
    "n.protocol + \'//\' +\n          window.location.hostname + \'/\'"
    " +\n          url.substr(this.mappedDomainNames_[i].length);\n"
    "      event.preventDefault();\n      return;\n    }\n  }\n};\n\n/*"
    "*\n * Initializes the client domain rewriter.\n * @param {stri"
    "ng} mappedDomainNames for which the url is to be rewritten.\n"
    " */\npagespeed.clientDomainRewriterInit = function(mappedDoma"
    "inNames) {\n  var clientDomainRewriter = new pagespeed.Client"
    "DomainRewriter(\n      mappedDomainNames);\n  pagespeed[\'clien"
    "tDomainRewriter\'] = clientDomainRewriter;\n  clientDomainRewr"
    "iter.addEventListeners();\n};\npagespeed[\'clientDomainRewriter"
    "Init\'] = pagespeed.clientDomainRewriterInit;\n";

}  // namespace net_instaweb
