// Copyright 2011 Google Inc. All Rights Reserved.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Automatically generated from ../../net/instaweb/rewriter/critical_css_beacon.js

namespace net_instaweb {

const char* JS_critical_css_beacon =
    "/*\n * Copyright 2013 Google Inc.\n *\n * Licensed under the Ap"
    "ache License, Version 2.0 (the \"License\");\n * you may not us"
    "e this file except in compliance with the License.\n * You ma"
    "y obtain a copy of the License at\n *\n *      http://www.apac"
    "he.org/licenses/LICENSE-2.0\n *\n * Unless required by applica"
    "ble law or agreed to in writing, software\n * distributed und"
    "er the License is distributed on an \"AS IS\" BASIS,\n * WITHOU"
    "T WARRANTIES OR CONDITIONS OF ANY KIND, either express or im"
    "plied.\n * See the License for the specific language governin"
    "g permissions and\n * limitations under the License.\n */\n\n/**"
    "\n * @fileoverview Code for detecting and sending to the serv"
    "er the critical CSS\n * selectors (selectors applying to any "
    "DOM elements on the page) on the client\n * side. To use, thi"
    "s script should be injected right before </body> with a call"
    "\n * to pagespeed.criticalCssBeaconInit(...) appended to it.\n"
    " *\n * @author jud@google.com (Jud Porter)\n */\n\n// TODO(jud):"
    " Reuse and share code with critical_images_beacon.js.\n\n// Ex"
    "porting functions using quoted attributes to prevent js comp"
    "iler from\n// renaming them.\n// See http://code.google.com/cl"
    "osure/compiler/docs/api-tutorial3.html#dangers\nwindow[\'pages"
    "peed\'] = window[\'pagespeed\'] || {};\nvar pagespeed = window[\'"
    "pagespeed\'];\n\n/**\n * @constructor\n * @param {string} beaconU"
    "rl The URL on the server to send the beacon to.\n * @param {s"
    "tring} htmlUrl Url of the page the beacon is being inserted "
    "on.\n * @param {string} optionsHash The hash of the rewrite o"
    "ptions. This is required\n *     to perform the property cach"
    "e lookup when the beacon is handled by the\n *     sever.\n * "
    "@param {Array.<string>} selectors List of the selectors on t"
    "he page.\n */\npagespeed.CriticalCssBeacon = function(beaconUr"
    "l, htmlUrl, optionsHash,\n                                   "
    "    selectors) {\n  this.beaconUrl_ = beaconUrl;\n  this.htmlU"
    "rl_ = htmlUrl;\n  this.optionsHash_ = optionsHash;\n  this.sel"
    "ectors_ = selectors;\n};\n\n/**\n * Send the beacon as an AJAX P"
    "OST request to the server.\n * @param {string} data The data "
    "to be sent in the POST.\n * @return {boolean} Return true if "
    "the request was sent.\n * @private\n */\npagespeed.CriticalCssB"
    "eacon.prototype.sendBeacon_ = function(data) {\n  var httpReq"
    "uest;\n  // TODO(jud): Use the closure goog.net.Xhrlo.send fu"
    "nction here once we have\n  // closure lib support in our sta"
    "tic JS files.\n  if (window.XMLHttpRequest) { // Mozilla, Saf"
    "ari, ...\n    httpRequest = new XMLHttpRequest();\n  } else if"
    " (window.ActiveXObject) { // IE\n    try {\n      httpRequest "
    "= new ActiveXObject(\'Msxml2.XMLHTTP\');\n    }\n    catch (e) {"
    "\n      try {\n        httpRequest = new ActiveXObject(\'Micros"
    "oft.XMLHTTP\');\n      }\n      catch (e2) {}\n    }\n  }\n  if (!"
    "httpRequest) {\n    return false;\n  }\n\n  httpRequest.open(\'PO"
    "ST\', this.beaconUrl_);\n  httpRequest.setRequestHeader(\n     "
    " \'Content-Type\', \'application/x-www-form-urlencoded\');\n  htt"
    "pRequest.send(data);\n  return true;\n};\n\n/**\n * Check if CSS "
    "selectors apply to DOM elements that are visible on initial "
    "page\n * load.\n * @private\n */\npagespeed.CriticalCssBeacon.pr"
    "ototype.checkCssSelectors_ = function() {\n  // Define the ma"
    "ximum size of a POST that the server will accept. We shouldn"
    "\'t\n  // send more data than this.\n  // TODO(jud): Factor out"
    " this const so that it matches kMaxPostSizeBytes, and\n  // s"
    "et to a smaller size based on typical critical CSS beacon si"
    "zes.\n  var MAX_DATA_LEN = 131072;\n\n  var critical_selectors "
    "= [];\n\n  for (var i = 0; i < this.selectors_.length; ++i) {\n"
    "    try {\n      // If this selector matched any DOM elements"
    ", then consider it critical.\n      if (document.querySelecto"
    "rAll(this.selectors_[i]).length > 0) {\n        critical_sele"
    "ctors.push(this.selectors_[i]);\n      }\n    } catch (e) {\n  "
    "    // SYNTAX_ERR is thrown if the browser can\'t parse a sel"
    "ector (eg, CSS3 in\n      // a CSS2.1 browser). Ignore these "
    "exceptions.\n      // TODO(jud): Consider if continue is the "
    "right thing to do here. It may\n      // be safer to mark thi"
    "s selector as critical if the browser didn\'t\n      // unders"
    "tand it.\n      continue;\n    }\n  }\n  var data = \'url=\' + enc"
    "odeURIComponent(this.htmlUrl_);\n  data += \'&oh=\' + this.opti"
    "onsHash_;\n  data += \'&cs=\';\n  for (var i = 0; i < critical_s"
    "electors.length; ++i) {\n    var tmp = (i > 0) ? \',\' : \'\';\n  "
    "  tmp += encodeURIComponent(critical_selectors[i]);\n    // T"
    "ODO(jud): Don\'t truncate the critical selectors list if we e"
    "xceed\n    // MAX_DATA_LEN. Either send a signal back that we"
    " exceeded the limit, or\n    // send multiple beacons back wi"
    "th all the data.\n    if ((data.length + tmp.length) > MAX_DA"
    "TA_LEN) {\n      break;\n    }\n    data += tmp;\n  }\n  // Expor"
    "t the URL for testing purposes.\n  pagespeed[\'criticalCssBeac"
    "onData\'] = data;\n  // TODO(jud): This beacon should coordina"
    "te with the add_instrumentation JS\n  // so that only one bea"
    "con request is sent if both filters are enabled.\n  this.send"
    "Beacon_(data);\n};\n\n/**\n * Runs the function when event is tr"
    "iggered.\n * @param {Window|Element} elem Element to attach h"
    "andler.\n * @param {string} ev Name of the event.\n * @param {"
    "function()} func New onload handler.\n *\n * TODO(nikhilmadan)"
    ": Avoid duplication with the DeferJs code.\n */\npagespeed.add"
    "Handler = function(elem, ev, func) {\n  if (elem.addEventList"
    "ener) {\n    elem.addEventListener(ev, func, false);\n  } else"
    " if (elem.attachEvent) {\n    elem.attachEvent(\'on\' + ev, fun"
    "c);\n  } else {\n    var oldHandler = elem[\'on\' + ev];\n    ele"
    "m[\'on\' + ev] = function() {\n      func.call(this);\n      if "
    "(oldHandler) {\n        oldHandler.call(this);\n      }\n    };"
    "\n  }\n};\n\n/**\n * Initialize.\n * @param {string} beaconUrl The"
    " URL on the server to send the beacon to.\n * @param {string}"
    " htmlUrl Url of the page the beacon is being inserted on.\n *"
    " @param {string} optionsHash The hash of the rewrite options"
    ".\n * @param {Array.<string>} selectors List of the selectors"
    " on the page.\n */\npagespeed.criticalCssBeaconInit = function"
    "(beaconUrl, htmlUrl, optionsHash,\n                          "
    "                 selectors) {\n  // Verify that the browser s"
    "upports the APIs we need and bail out early if we\n  // don\'t"
    ".\n  if (!document.querySelectorAll) {\n    return;\n  }\n\n  var"
    " temp = new pagespeed.CriticalCssBeacon(beaconUrl, htmlUrl, "
    "optionsHash,\n                                             se"
    "lectors);\n  // Add event to the onload handler to scan selec"
    "tors and beacon back which\n  // apply to critical elements.\n"
    "  var beacon_onload = function() {\n    // Attempt not to blo"
    "ck other onload events on the page by wrapping in\n    // set"
    "Timeout().\n    window.setTimeout(function() {\n      temp.che"
    "ckCssSelectors_();\n    }, 0);\n  };\n  pagespeed.addHandler(wi"
    "ndow, \'load\', beacon_onload);\n};\n\npagespeed[\'criticalCssBeac"
    "onInit\'] = pagespeed.criticalCssBeaconInit;\n";

}  // namespace net_instaweb
