// Copyright 2011 Google Inc. All Rights Reserved.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Automatically generated from ../../net/instaweb/rewriter/critical_images_beacon.js

namespace net_instaweb {

const char* JS_critical_images_beacon =
    "/*\n * Copyright 2013 Google Inc.\n *\n * Licensed under the Ap"
    "ache License, Version 2.0 (the \"License\");\n * you may not us"
    "e this file except in compliance with the License.\n * You ma"
    "y obtain a copy of the License at\n *\n *      http://www.apac"
    "he.org/licenses/LICENSE-2.0\n *\n * Unless required by applica"
    "ble law or agreed to in writing, software\n * distributed und"
    "er the License is distributed on an \"AS IS\" BASIS,\n * WITHOU"
    "T WARRANTIES OR CONDITIONS OF ANY KIND, either express or im"
    "plied.\n * See the License for the specific language governin"
    "g permissions and\n * limitations under the License.\n */\n\n/**"
    "\n * @fileoverview Code for detecting and sending to server t"
    "he critical images\n * (images above the fold) on the client "
    "side.\n *\n * @author jud@google.com (Jud Porter)\n */\n\n// Expo"
    "rting functions using quoted attributes to prevent js compil"
    "er from\n// renaming them.\n// See http://code.google.com/clos"
    "ure/compiler/docs/api-tutorial3.html#dangers\nwindow[\'pagespe"
    "ed\'] = window[\'pagespeed\'] || {};\nvar pagespeed = window[\'pa"
    "gespeed\'];\n\n/**\n * @constructor\n * @param {string} beaconUrl"
    " The URL on the server to send the beacon to.\n * @param {str"
    "ing} htmlUrl Url of the page the beacon is being inserted on"
    ".\n * @param {string} optionsHash The hash of the rewrite opt"
    "ions. This is required\n *     to perform the property cache "
    "lookup when the beacon is handled by the\n *     sever.\n */\np"
    "agespeed.CriticalImagesBeacon = function(beaconUrl, htmlUrl,"
    " optionsHash) {\n  this.beaconUrl_ = beaconUrl;\n  this.htmlUr"
    "l_ = htmlUrl;\n  this.optionsHash_ = optionsHash;\n  this.wind"
    "owSize_ = this.getWindowSize_();\n  this.imgLocations_ = {};\n"
    "};\n\n/**\n * Returns the size of the window.\n * @return {{\n * "
    "    height: (number),\n *     width: (number)\n * }}\n * @priva"
    "te\n */\npagespeed.CriticalImagesBeacon.prototype.getWindowSiz"
    "e_ = function() {\n  var height = window.innerHeight || docum"
    "ent.documentElement.clientHeight ||\n      document.body.clie"
    "ntHeight;\n  var width = window.innerWidth || document.docume"
    "ntElement.clientWidth ||\n      document.body.clientWidth;\n  "
    "return {\n    height: height,\n    width: width\n  };\n};\n\n/**\n "
    "* Returns the absolute position of the top left corner of th"
    "e element.\n * @param {Element} element DOM element to calcul"
    "ate the location of.\n * @return {{\n *      top: (number),\n *"
    "      left: (number)\n * }}\n * @private\n */\npagespeed.Critica"
    "lImagesBeacon.prototype.elLocation_ = function(element) {\n  "
    "var rect = element.getBoundingClientRect();\n\n  // getBoundin"
    "gClientRect() is w.r.t. the viewport. Add the amount scolled"
    " to\n  // calculate the absolute position of the element.\n  v"
    "ar scroll_x, scroll_y;\n  // From https://developer.mozilla.o"
    "rg/en-US/docs/DOM/window.scrollX\n  scroll_x = (window.pageXO"
    "ffset !== undefined) ? window.pageXOffset :\n      (document."
    "documentElement ||\n       document.body.parentNode ||\n      "
    " document.body).scrollLeft;\n  scroll_y = (window.pageYOffset"
    " !== undefined) ? window.pageYOffset :\n      (document.docum"
    "entElement ||\n       document.body.parentNode ||\n       docu"
    "ment.body).scrollTop;\n\n  return {\n    top: rect.top + scroll"
    "_y,\n    left: rect.left + scroll_x\n  };\n};\n\n/**\n * Returns t"
    "rue if an element is visible upon initial page load.\n * @par"
    "am {Element} element The DOM element to check for visibility"
    ".\n * @return {boolean} True if the element is critical.\n * @"
    "private\n */\npagespeed.CriticalImagesBeacon.prototype.isCriti"
    "cal_ = function(element) {\n  // TODO(jud): We can perform a "
    "more efficient critical image check if lazyload\n  // images "
    "is enabled, and this beacon code runs after the lazyload JS "
    "has\n  // initially executed. Specifically, we know an image "
    "is not critical if it\n  // still has the \'pagespeed_lazy_src"
    "\' attribute, meaning that the image was\n  // not visible in "
    "the viewport yet. This will save us potentially many calls\n "
    " // to the expensive getBoundingClientRect().\n\n  // Make sur"
    "e the element is visible first before checking its position "
    "on the\n  // page. Note, this check works correctly with the "
    "lazyload placeholder image,\n  // since that image is a 1x1 p"
    "ixel, and styling it display=none also sets\n  // offsetWidth"
    " and offsetHeight to 0.\n  if (element.offsetWidth <= 0 && el"
    "ement.offsetHeight <= 0) {\n    return false;\n  }\n\n  var elLo"
    "cation = this.elLocation_(element);\n  // Only return 1 image"
    " as critical if there are multiple images that have the\n  //"
    " same location. This is to handle sliders with many images i"
    "n the same\n  // location, but most of which only appear afte"
    "r onload.\n  var elLocationStr = JSON.stringify(elLocation);\n"
    "  if (this.imgLocations_.hasOwnProperty(elLocationStr)) {\n  "
    "  return false;\n  } else {\n    this.imgLocations_[elLocation"
    "Str] = true;\n  }\n\n  return (elLocation.top <= this.windowSiz"
    "e_.height &&\n          elLocation.left <= this.windowSize_.w"
    "idth);\n};\n\n/**\n * Send the beacon as an AJAX POST request to"
    " the server.\n * @param {string} data The data to be sent in "
    "the POST.\n * @return {boolean} Return true if the request wa"
    "s sent.\n * @private\n */\npagespeed.CriticalImagesBeacon.proto"
    "type.sendBeacon_ = function(data) {\n  var httpRequest;\n  // "
    "TODO(jud): Use the closure goog.net.Xhrlo.send function here"
    " once we have\n  // closure lib support in our static JS file"
    "s.\n  if (window.XMLHttpRequest) { // Mozilla, Safari, ...\n  "
    "  httpRequest = new XMLHttpRequest();\n  } else if (window.Ac"
    "tiveXObject) { // IE\n    try {\n      httpRequest = new Activ"
    "eXObject(\'Msxml2.XMLHTTP\');\n    }\n    catch (e) {\n      try "
    "{\n        httpRequest = new ActiveXObject(\'Microsoft.XMLHTTP"
    "\');\n      }\n      catch (e2) {}\n    }\n  }\n  if (!httpRequest"
    ") {\n    return false;\n  }\n\n  httpRequest.open(\'POST\', this.b"
    "eaconUrl_);\n  httpRequest.setRequestHeader(\n      \'Content-T"
    "ype\', \'application/x-www-form-urlencoded\');\n  httpRequest.se"
    "nd(data);\n  return true;\n};\n\n/**\n * Check position of images"
    " and input tags and beacon back images that are\n * visible o"
    "n initial page load.\n * @private\n */\npagespeed.CriticalImage"
    "sBeacon.prototype.checkCriticalImages_ = function() {\n  // D"
    "efine the maximum size of a POST that the server will accept"
    ". We shouldn\'t\n  // send more data than this.\n  // TODO(jud)"
    ": Factor out this const so that it matches kMaxPostSizeBytes"
    ".\n  var MAX_DATA_LEN = 131072;\n\n  // List of tags whose elem"
    "ents we will check to see if they are critical.\n  var tags ="
    " [\'img\', \'input\'];\n  // Use an object to store the critical_"
    "imgs so that we get a unique (no\n  // duplicates) list of th"
    "em.\n  var critical_imgs = {};\n\n  for (var i = 0; i < tags.le"
    "ngth; ++i) {\n    var elements = document.getElementsByTagNam"
    "e(tags[i]);\n    for (var j = 0; j < elements.length; ++j) {\n"
    "      // TODO(jud): Remove the check for getBoundingClientRe"
    "ct below, either by\n      // making elLocation_ work correct"
    "ly if it isn\'t defined, or updating the\n      // user agent "
    "whitelist to exclude UAs that don\'t support it correctly.\n  "
    "    if (elements[j].hasAttribute(\'pagespeed_url_hash\') &&\n  "
    "        elements[j].getBoundingClientRect &&\n          this."
    "isCritical_(elements[j])) {\n        critical_imgs[elements[j"
    "].getAttribute(\'pagespeed_url_hash\')] = true;\n      }\n    }\n"
    "  }\n  critical_imgs = Object.keys(critical_imgs);\n  if (crit"
    "ical_imgs.length != 0) {\n    var data = \'url=\' + encodeURICo"
    "mponent(this.htmlUrl_);\n    data += \'&oh=\' + this.optionsHas"
    "h_;\n    data += \'&ci=\' + encodeURIComponent(critical_imgs[0]"
    ");\n    for (var i = 1; i < critical_imgs.length; ++i) {\n    "
    "  var tmp = \',\' + encodeURIComponent(critical_imgs[i]);\n    "
    "  if ((data.length + tmp.length) > MAX_DATA_LEN) {\n        b"
    "reak;\n      }\n      data += tmp;\n    }\n    // Export the URL"
    " for testing purposes.\n    pagespeed[\'criticalImagesBeaconDa"
    "ta\'] = data;\n    // TODO(jud): This beacon should coordinate"
    " with the add_instrumentation JS\n    // so that only one bea"
    "con request is sent if both filters are enabled.\n    this.se"
    "ndBeacon_(data);\n  }\n};\n\n/**\n * Runs the function when event"
    " is triggered.\n * @param {Window|Element} elem Element to at"
    "tach handler.\n * @param {string} ev Name of the event.\n * @p"
    "aram {function()} func New onload handler.\n *\n * TODO(nikhil"
    "madan): Avoid duplication with the DeferJs code.\n */\npagespe"
    "ed.addHandler = function(elem, ev, func) {\n  if (elem.addEve"
    "ntListener) {\n    elem.addEventListener(ev, func, false);\n  "
    "} else if (elem.attachEvent) {\n    elem.attachEvent(\'on\' + e"
    "v, func);\n  } else {\n    var oldHandler = elem[\'on\' + ev];\n "
    "   elem[\'on\' + ev] = function() {\n      func.call(this);\n   "
    "   if (oldHandler) {\n        oldHandler.call(this);\n      }\n"
    "    };\n  }\n};\n\n/**\n * Initialize.\n * @param {string} beaconU"
    "rl The URL on the server to send the beacon to.\n * @param {s"
    "tring} htmlUrl Url of the page the beacon is being inserted "
    "on.\n * @param {string} optionsHash The hash of the rewrite o"
    "ptions.\n */\npagespeed.criticalImagesBeaconInit = function(be"
    "aconUrl, htmlUrl, optionsHash) {\n  var temp = new pagespeed."
    "CriticalImagesBeacon(\n      beaconUrl, htmlUrl, optionsHash)"
    ";\n  // Add event to the onload handler to scan images and be"
    "acon back the visible\n  // ones.\n  var beacon_onload = funct"
    "ion() {\n    // Attempt not to block other onload events on t"
    "he page by wrapping in\n    // setTimeout().\n    // TODO(jud)"
    ": checkCriticalImages_ should not run until after lazyload\n "
    "   // images completes. This will allow us to reduce the com"
    "plexity of managing\n    // the interaction between the beaco"
    "n and the lazyload jS, and to do a more\n    // efficient che"
    "ck for image visibility.\n    window.setTimeout(function() {\n"
    "      temp.checkCriticalImages_();\n    }, 0);\n  };\n  pagespe"
    "ed.addHandler(window, \'load\', beacon_onload);\n};\n\npagespeed["
    "\'criticalImagesBeaconInit\'] = pagespeed.criticalImagesBeacon"
    "Init;\n";

}  // namespace net_instaweb
