// Copyright 2011 Google Inc. All Rights Reserved.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Automatically generated from ../../net/instaweb/rewriter/delay_images.js

namespace net_instaweb {

const char* JS_delay_images =
    "/*\n * Copyright 2011 Google Inc.\n *\n * Licensed under the Ap"
    "ache License, Version 2.0 (the \"License\");\n * you may not us"
    "e this file except in compliance with the License.\n * You ma"
    "y obtain a copy of the License at\n *\n *      http://www.apac"
    "he.org/licenses/LICENSE-2.0\n *\n * Unless required by applica"
    "ble law or agreed to in writing, software\n * distributed und"
    "er the License is distributed on an \"AS IS\" BASIS,\n * WITHOU"
    "T WARRANTIES OR CONDITIONS OF ANY KIND, either express or im"
    "plied.\n * See the License for the specific language governin"
    "g permissions and\n * limitations under the License.\n */\n\n/**"
    "\n * @fileoverview Code for loading high resolution critical "
    "images.\n * This javascript is part of DelayImages filter.\n *"
    "\n * @author pulkitg@google.com (Pulkit Goyal)\n */\n\n// Export"
    "ing functions using quoted attributes to prevent js compiler"
    " from\n// renaming them.\n// See http://code.google.com/closur"
    "e/compiler/docs/api-tutorial3.html#dangers\nwindow[\'pagespeed"
    "\'] = window[\'pagespeed\'] || {};\nvar pagespeed = window[\'page"
    "speed\'];\n\n/**\n * @constructor\n */\npagespeed.DelayImages = fu"
    "nction() {\n  /*\n   * Boolean that controls whether the event"
    " handlers for lazy load are already\n   * registered.\n   * @t"
    "ype {boolean}\n   * @private\n   */\n  this.lazyLoadHighResHand"
    "lersRegistered_ = false;\n\n  /*\n   * Boolean that controls th"
    "e logic to replace low res images with high res\n   * only on"
    "ce.\n   * @type {boolean}\n   * @private\n   */\n  this.highResR"
    "eplaced_ = false;\n};\n\n/**\n * For given elements, replace src"
    " with pagespeed_high_res_src if present.\n * @param {NodeList"
    ".<Element>} elements list of DOM elements to check.\n */\npage"
    "speed.DelayImages.prototype.replaceElementSrc = function(ele"
    "ments) {\n  for (var i = 0; i < elements.length; ++i) {\n    v"
    "ar src = elements[i].getAttribute(\'pagespeed_high_res_src\');"
    "\n    if (src) {\n      elements[i].setAttribute(\'src\', src);\n"
    "    }\n  }\n};\npagespeed.DelayImages.prototype[\'replaceElement"
    "Src\'] =\n  pagespeed.DelayImages.prototype.replaceElementSrc;"
    "\n\n/**\n * Register the event handlers to lazy load the high r"
    "es images. This is\n * called only when lazyload_high_res_exp"
    "erimental flag is enabled.\n */\npagespeed.DelayImages.prototy"
    "pe.registerLazyLoadHighRes = function() {\n  // Add event han"
    "dlers only once\n  if (this.lazyLoadHighResHandlersRegistered"
    "_) {\n    this.highResReplaced_ = false;\n    return;\n  }\n\n  v"
    "ar elem = document.body;\n  var interval = 500;\n  var tapStar"
    "t, tapEnd = 0;\n\n  this.highResReplaced = false;\n  if (\'ontou"
    "chstart\' in elem) {\n    elem.addEventListener(\'touchstart\', "
    "function(e) {\n      tapStart = Date.now();\n    }, false);\n\n "
    "   elem.addEventListener(\'touchend\', function(e) {\n      tap"
    "End = Date.now();\n      // Load the high res images if there"
    " is a multi-touch or if the tap\n      // duration is less th"
    "an 500ms i.e single click. The timer catches the\n      // cl"
    "ick event sooner than the click handler on most phones.\n    "
    "  if ((e.changedTouches != null && e.changedTouches.length ="
    "= 2) ||\n          (e.touches != null && e.touches.length == "
    "2) ||\n          tapEnd - tapStart < interval) {\n        this"
    ".loadHighRes();\n      }\n    }, false);\n  } else {\n    elem.a"
    "ddEventListener(\'onclick\', function(e) {\n      this.loadHigh"
    "Res();\n    }, false);\n  }\n  elem.addEventListener(\'onload\', "
    "function(e) {\n    this.loadHighRes();\n  }, false);\n  this.la"
    "zyLoadHighResHandlersRegistered_ = true;\n};\n\npagespeed.Delay"
    "Images.prototype[\'registerLazyLoadHighRes\'] =\n  pagespeed.De"
    "layImages.prototype.registerLazyLoadHighRes;\n\n/**\n * Trigger"
    "ed from event handlers that were previously registered. Repl"
    "aces\n * low res images with high res sources.\n */\npagespeed."
    "DelayImages.prototype.loadHighRes = function() {\n  if (!this"
    ".highResReplaced_) {\n    this.replaceWithHighRes();\n    this"
    ".highResReplaced_ = true;\n  }\n};\n\n/**\n * Replaces low resolu"
    "tion image with high resolution image.\n */\npagespeed.DelayIm"
    "ages.prototype.replaceWithHighRes = function() {\n  this.repl"
    "aceElementSrc(document.getElementsByTagName(\'img\'));\n  this."
    "replaceElementSrc(document.getElementsByTagName(\'input\'));\n}"
    ";\npagespeed.DelayImages.prototype[\'replaceWithHighRes\'] =\n  "
    "pagespeed.DelayImages.prototype.replaceWithHighRes;\n\n/**\n * "
    "Initializes the delay images module.\n */\npagespeed.delayImag"
    "esInit = function() {\n  var temp = new pagespeed.DelayImages"
    "();\n  pagespeed[\'delayImages\'] = temp;\n};\n\npagespeed[\'delayI"
    "magesInit\'] = pagespeed.delayImagesInit;\n";

}  // namespace net_instaweb
