// Copyright 2011 Google Inc. All Rights Reserved.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Automatically generated from ../../net/instaweb/rewriter/detect_reflow.js

namespace net_instaweb {

const char* JS_detect_reflow =
    "/*\n * Copyright 2012 Google Inc.\n *\n * Licensed under the Ap"
    "ache License, Version 2.0 (the \"License\");\n * you may not us"
    "e this file except in compliance with the License.\n * You ma"
    "y obtain a copy of the License at\n *\n *      http://www.apac"
    "he.org/licenses/LICENSE-2.0\n *\n * Unless required by applica"
    "ble law or agreed to in writing, software\n * distributed und"
    "er the License is distributed on an \"AS IS\" BASIS,\n * WITHOU"
    "T WARRANTIES OR CONDITIONS OF ANY KIND, either express or im"
    "plied.\n * See the License for the specific language governin"
    "g permissions and\n * limitations under the License.\n */\n\n\n/*"
    "*\n * @fileoverview Detecting reflows due to deferred js exec"
    "ution.  To be used in\n * conjunction with js_defer.js.\n *\n *"
    " @author sriharis@google.com (Srihari Sukumaran)\n */\n\n// Exp"
    "orting functions using quoted attributes to prevent js compi"
    "ler from\n// renaming them.\n// See http://code.google.com/clo"
    "sure/compiler/docs/api-tutorial3.html#dangers\nwindow[\'pagesp"
    "eed\'] = window[\'pagespeed\'] || {};\nvar pagespeed = window[\'p"
    "agespeed\'];\n\n/**\n * @constructor\n */\npagespeed.DetectReflow "
    "= function() {\n  /**\n   * Height of divs before scripts exec"
    "uted.\n   * @type {!Object.<string, number>}\n   * @private\n  "
    " */\n  this.preScriptHeights_ = {};\n\n  /**\n   * String that c"
    "ontains a comma separated list of \"div:height\", where height"
    "\n   * represents the final rendered height after scripts exe"
    "cuted.\n   * @type {!string}\n   * @private\n   */\n  this.reflo"
    "wElementHeights_ = \'\';\n\n  /**\n   * Flag to indicate that def"
    "erred script execution is done.\n   * @type {!boolean}\n   * @"
    "private\n   */\n  this.jsDeferDone_ = false;\n};\n\n/**\n * Return"
    "s preScriptHeights_ object.\n * @return {!Object.<string, num"
    "ber>} Height of divs before scripts executed.\n */\npagespeed."
    "DetectReflow.prototype.getPreScriptHeights = function() {\n  "
    "return this.preScriptHeights_;\n};\npagespeed.DetectReflow.pro"
    "totype[\'getPreScriptHeights\'] =\n  pagespeed.DetectReflow.pro"
    "totype.getPreScriptHeights;\n\n/**\n * Returns reflowElementHei"
    "ghts_ string.\n * @return {!string}  A comma separated list o"
    "f \"div:height\", where height\n * represents the final rendere"
    "d height after scripts executed.\n */\npagespeed.DetectReflow."
    "prototype.getReflowElementHeight = function() {\n  return thi"
    "s.reflowElementHeights_;\n};\npagespeed.DetectReflow.prototype"
    "[\'getReflowElementHeight\'] =\n  pagespeed.DetectReflow.protot"
    "ype.getReflowElementHeight;\n\n/**\n * Returns jsDeferDone_ boo"
    "lean.\n * @return {!boolean}  Returns true if reflow detectio"
    "n is done.\n */\npagespeed.DetectReflow.prototype.isJsDeferDon"
    "e = function() {\n  return this.jsDeferDone_;\n};\npagespeed.De"
    "tectReflow.prototype[\'isJsDeferDone\'] =\n  pagespeed.DetectRe"
    "flow.prototype.isJsDeferDone;\n\n/**\n * For all divs in preScr"
    "iptHeights_, if the clientHeight now is different from\n * th"
    "e div\'s height mapped in preScriptHeights_ then \'<div id>:<c"
    "urrent height>\'\n * is appended to reflowElementHeights_.\n */"
    "\npagespeed.DetectReflow.prototype.findChangedDivsAfterDeferr"
    "edJs = function() {\n  if (!this.preScriptHeights_ && console"
    ") {\n    console.log(\'preScriptHeights_ is not available\');\n "
    " }\n  // Check reflow\n  var newDivs = document.getElementsByT"
    "agName(\'div\');\n  var newLen = newDivs.length;\n  for (var i ="
    " 0; i < newLen; ++i) {\n    var div = newDivs[i];\n    if (!di"
    "v.hasAttribute(\'id\')) {\n      continue;\n    }\n    var divId "
    "= div.getAttribute(\'id\');\n    if (this.preScriptHeights_[div"
    "Id] != undefined) {\n      if (this.preScriptHeights_[divId] "
    "!= div.clientHeight) {\n        this.reflowElementHeights_ = "
    "this.reflowElementHeights_ + divId + \':\' +\n            windo"
    "w.getComputedStyle(div, null).getPropertyValue(\'height\') + \'"
    ",\';\n      }\n    }\n  }\n};\npagespeed.DetectReflow.prototype[\'f"
    "indChangedDivsAfterDeferredJs\'] =\n  pagespeed.DetectReflow.p"
    "rototype.findChangedDivsAfterDeferredJs;\n\n/**\n * For all div"
    "s with attribute \'id\', adds a mapping from div \'id\' to\n * cl"
    "ientHeight in preScriptHeights_.  Executed as \'BeforeDeferRu"
    "n\' hook in\n * js_defer.js.\n */\npagespeed.DetectReflow.protot"
    "ype.labelDivsBeforeDeferredJs = function() {\n  var divs = do"
    "cument.getElementsByTagName(\'div\');\n  var len = divs.length;"
    "\n  for (var i = 0; i < len; ++i) {\n    var div = divs[i];\n  "
    "  if (div.hasAttribute(\'id\') && div.clientHeight != undefine"
    "d) {\n      this.preScriptHeights_[div.getAttribute(\'id\')] = "
    "div.clientHeight;\n    }\n    // TODO(sriharis):  How to handl"
    "e divs with \'class\' and no \'id\'?\n  }\n};\npagespeed.DetectRefl"
    "ow.prototype[\'labelDivsBeforeDeferredJs\'] =\n  pagespeed.Dete"
    "ctReflow.prototype.labelDivsBeforeDeferredJs;\n\n/**\n * To be "
    "executed from \'AfterDeferRun\' hook in js_defer.js.  Sets the"
    "\n * jsDeferDone_ flag to true.\n */\npagespeed.DetectReflow.pr"
    "ototype.setJsDeferDone = function() {\n  this.jsDeferDone_ = "
    "true;\n};\npagespeed.DetectReflow.prototype[\'setJsDeferDone\'] "
    "=\n  pagespeed.DetectReflow.prototype.setJsDeferDone;\n\nif (pa"
    "gespeed[\'deferJs\'] != \'undefined\' &&\n    pagespeed[\'deferJs\'"
    "][\'addBeforeDeferRunFunctions\'] != \'undefined\' &&\n    pagesp"
    "eed[\'deferJs\'][\'addAfterDeferRunFunctions\'] != \'undefined\') "
    "{\n  var x = new pagespeed.DetectReflow();\n  pagespeed[\'detec"
    "tReflow\'] = x;\n\n  var pre = function() {\n    pagespeed[\'dete"
    "ctReflow\'][\'labelDivsBeforeDeferredJs\']();\n  };\n  pagespeed["
    "\'deferJs\'][\'addBeforeDeferRunFunctions\'](pre);\n\n  var post ="
    " function() {\n    pagespeed[\'detectReflow\'][\'setJsDeferDone\'"
    "]();\n  };\n  pagespeed[\'deferJs\'][\'addAfterDeferRunFunctions\'"
    "](post);\n}\n";

}  // namespace net_instaweb
