// Copyright 2011 Google Inc. All Rights Reserved.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Automatically generated from ../../net/instaweb/rewriter/deterministic.js

namespace net_instaweb {

const char* JS_deterministic =
    "/*\n * Copyright 2012 Google Inc.\n *\n * Licensed under the Ap"
    "ache License, Version 2.0 (the \"License\");\n * you may not us"
    "e this file except in compliance with the License.\n * You ma"
    "y obtain a copy of the License at\n *\n *      http://www.apac"
    "he.org/licenses/LICENSE-2.0\n *\n * Unless required by applica"
    "ble law or agreed to in writing, software\n * distributed und"
    "er the License is distributed on an \"AS IS\" BASIS,\n * WITHOU"
    "T WARRANTIES OR CONDITIONS OF ANY KIND, either express or im"
    "plied.\n * See the License for the specific language governin"
    "g permissions and\n * limitations under the License.\n */\n\n// "
    "This js redefines the non-deterministic parts of JS, such as"
    " Date and\n// Math.random, so that contents of the rewritten "
    "page are more or less\n// deterministic when loaded repeatedl"
    "y. This can help in reducing variance\n// found while measuri"
    "ng page load metrics over time.\n\nvar orig_date = Date;\nvar r"
    "andom_count = 0;\nvar date_count = 0;\nvar random_seed = 0.462"
    ";\nvar time_seed = 1204251968254;\nvar random_count_threshold "
    "= 25;\nvar date_count_threshold = 25;\nMath.random = function("
    ") {\n  random_count++;\n  if (random_count > random_count_thre"
    "shold) {\n   random_seed += 0.1;\n   random_count = 1;\n  }\n  r"
    "eturn (random_seed % 1);\n};\nDate = function() {\n  if (this i"
    "nstanceof Date) {\n    date_count++;\n    if (date_count > dat"
    "e_count_threshold) {\n      time_seed += 50;\n      date_count"
    " = 1;\n    }\n    switch (arguments.length) {\n    case 0: retu"
    "rn new orig_date(time_seed);\n    case 1: return new orig_dat"
    "e(arguments[0]);\n    default: return new orig_date(arguments"
    "[0], arguments[1],\n       arguments.length >= 3 ? arguments["
    "2] : 1,\n       arguments.length >= 4 ? arguments[3] : 0,\n   "
    "    arguments.length >= 5 ? arguments[4] : 0,\n       argumen"
    "ts.length >= 6 ? arguments[5] : 0,\n       arguments.length >"
    "= 7 ? arguments[6] : 0);\n    }\n  }\n  return new Date().toStr"
    "ing();\n};\nDate.__proto__ = orig_date;\nDate.prototype.constru"
    "ctor = Date;\norig_date.now = function() {\n  return new Date("
    ").getTime();\n};\n";

}  // namespace net_instaweb
