// Copyright 2011 Google Inc. All Rights Reserved.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Automatically generated from ../../net/instaweb/rewriter/js_defer.js

namespace net_instaweb {

const char* JS_js_defer =
    "/*\n * Copyright 2011 Google Inc.\n *\n * Licensed under the Ap"
    "ache License, Version 2.0 (the \"License\");\n * you may not us"
    "e this file except in compliance with the License.\n * You ma"
    "y obtain a copy of the License at\n *\n *      http://www.apac"
    "he.org/licenses/LICENSE-2.0\n *\n * Unless required by applica"
    "ble law or agreed to in writing, software\n * distributed und"
    "er the License is distributed on an \"AS IS\" BASIS,\n * WITHOU"
    "T WARRANTIES OR CONDITIONS OF ANY KIND, either express or im"
    "plied.\n * See the License for the specific language governin"
    "g permissions and\n * limitations under the License.\n */\n\n/**"
    "\n * @fileoverview Code for deferring javascript on client si"
    "de.\n * This javascript is part of JsDefer filter.\n *\n * @aut"
    "hor atulvasu@google.com (Atul Vasu)\n */\n\n// Defer javascript"
    " will be executed in two phases. First phase will be for\n// "
    "high priority scripts and second phase is for low priority s"
    "cripts. Order\n// of execution will be:\n// 1) High priority s"
    "cripts.\n// 2) Low priority scripts.\n// 3) Onload of high pri"
    "ority scripts.\n// 4) Onload of low priority scripts.\n//\n// I"
    "n case of blink, order will be:\n// 1) High priority scripts "
    "present in above the fold.\n// 2) Low priority scripts presen"
    "t in above the fold.\n// 3) High priority scripts which are b"
    "elow the fold.\n// 4) Low priority scripts which are below th"
    "e fold.\n// 5) Onload of high priority scripts.\n// 6) Onload "
    "of low priority scripts.\n//\n// Exporting functions using quo"
    "ted attributes to prevent js compiler from\n// renaming them."
    "\n// See http://code.google.com/closure/compiler/docs/api-tut"
    "orial3.html#dangers\nwindow[\'pagespeed\'] = window[\'pagespeed\'"
    "] || {};\nvar pagespeed = window[\'pagespeed\'];\n\npagespeed[\'de"
    "ferJsNs\'] = {};\nvar deferJsNs = pagespeed[\'deferJsNs\'];\n\n/**"
    "\n * @constructor\n */\ndeferJsNs.DeferJs = function() {\n  /**\n"
    "   * Queue of tasks that need to be executed in order.\n   * "
    "@type {!Array.<function()>}\n   * @private\n   */\n  this.queue"
    "_ = [];\n\n  /**\n   * Array of logs, for debugging.\n   * @type"
    " {Array.<string>}\n   */\n  this.logs = [];\n\n  /**\n   * Next i"
    "tem in the queue to be executed.\n   * @type {!number}\n   * @"
    "private\n   */\n  this.next_ = 0;\n\n  /**\n   * Number of script"
    "s dynamically inserted which are not yet executed.\n   * @typ"
    "e {!number}\n   * @private\n   */\n  this.dynamicInsertedScript"
    "Count_ = 0;\n\n  /**\n   * Scripts dynamically inserted by othe"
    "r scripts.\n   * @type {Array.<Element>}\n   * @private\n   */\n"
    "  this.dynamicInsertedScript_ = [];\n\n  /**\n   * document.wri"
    "te() strings get buffered here, they get rendered when the\n "
    "  * current script is finished executing.\n   * @private\n   *"
    "/\n  this.documentWriteHtml_ = \'\';\n\n  // TODO(sriharis):  Can"
    " we have a listener module that is used for the\n  // followi"
    "ng.\n\n  /**\n   * Map of events to event listeners.\n   * @type"
    " {!Object}\n   * @private\n   */\n  this.eventListernersMap_ = "
    "{};\n\n  /**\n   * Valid Mime types for Javascript.\n   */\n  thi"
    "s.jsMimeTypes =\n      [\'application/ecmascript\',\n       \'app"
    "lication/javascript\',\n       \'application/x-ecmascript\',\n   "
    "    \'application/x-javascript\',\n       \'text/ecmascript\',\n  "
    "     \'text/javascript\',\n       \'text/javascript1.0\',\n       "
    "\'text/javascript1.1\',\n       \'text/javascript1.2\',\n       \'t"
    "ext/javascript1.3\',\n       \'text/javascript1.4\',\n       \'tex"
    "t/javascript1.5\',\n       \'text/jscript\',\n       \'text/livesc"
    "ript\',\n       \'text/x-ecmascript\',\n       \'text/x-javascript"
    "\'];\n\n  /**\n   * Original document.getElementById handler.\n  "
    " * @private\n   */\n  this.origGetElementById_ = document.getE"
    "lementById;\n\n  /**\n   * Original document.getElementsByTagNa"
    "me handler.\n   * @private\n   */\n  this.origGetElementsByTagN"
    "ame_ = document.getElementsByTagName;\n\n  /**\n   * Original d"
    "ocument.write handler.\n   * @private\n   */\n  this.origDocWri"
    "te_ = document.write;\n\n  /**\n   * Original document.writeln "
    "handler.\n   * @private\n   */\n  this.origDocWriteln_ = docume"
    "nt.writeln;\n\n  /**\n   * Original document.open handler.\n   *"
    " @private\n   */\n  this.origDocOpen_ = document.open;\n\n  /**\n"
    "   * Original document.close handler.\n   * @private\n   */\n  "
    "this.origDocClose_ = document.close;\n\n  /**\n   * Original do"
    "cument.addEventListener handler.\n   * @private\n   */\n  this."
    "origDocAddEventListener_ = document.addEventListener;\n\n  /**"
    "\n   * Original window.addEventListener handler.\n   * @privat"
    "e\n   */\n  this.origWindowAddEventListener_ = window.addEvent"
    "Listener;\n\n  /**\n   * Original document.addEventListener han"
    "dler.\n   * @private\n   */\n  this.origDocAttachEvent_ = docum"
    "ent.attachEvent;\n\n  /**\n   * Original window.addEventListene"
    "r handler.\n   * @private\n   */\n  this.origWindowAttachEvent_"
    " = window.attachEvent;\n\n  /**\n   * Original document.createE"
    "lement handler.\n   * @private\n   */\n  this.origCreateElement"
    "_ = document.createElement;\n\n  /**\n   * Maintains the curren"
    "t state for the deferJs.\n   * @type {!number}\n   * @private\n"
    "   */\n  this.state_ = deferJsNs.DeferJs.STATES.NOT_STARTED;\n"
    "\n  /**\n   * Maintains the last fired event.\n   * @type {!num"
    "ber}\n   * @private\n   */\n  this.eventState_ = deferJsNs.Defe"
    "rJs.EVENT.NOT_STARTED;\n\n  /**\n   * This variable indicates w"
    "hether deferJs is called for the first time.\n   * This is se"
    "t to false if deferJs is called again.\n   * @private\n   */\n "
    " this.firstIncrementalRun_ = true;\n\n  /**\n   * This variable"
    " indicates whether deferJs is called for the last time.\n   *"
    " This is set to false in registerScriptTags if deferJs will "
    "be called again\n   * @private\n   */\n  this.lastIncrementalRu"
    "n_ = true;\n\n  /**\n   * Callback to call when current increme"
    "ntal scripts are done executing.\n   * @private\n   */\n  this."
    "incrementalScriptsDoneCallback_ = null;\n\n  /**\n   * This var"
    "iable counts the total number of async scripts created by no"
    " defer\n   * scripts.\n   * @type {!number}\n   * @private\n   *"
    "/\n  this.noDeferAsyncScriptsCount_ = 0;\n\n  /**\n   * Async sc"
    "ripts created by no defer scripts.\n   * @type {Array.<Elemen"
    "t>}\n   * @private\n   */\n  this.noDeferAsyncScripts_ = [];\n\n "
    " /**\n   * Generated Html to prefetch the js files.\n   * @typ"
    "e {string}\n   * @private\n   */\n  this.prefetchScriptsHtml_ ="
    " \'\';\n\n  /**\n   * Type of the javascript node that will get e"
    "xecuted.\n   * @type {string}\n   * @private\n   */\n  this.psaS"
    "criptType_ = \'\';\n\n  /**\n   * Attribute added for nodes which"
    " are not processed yet.\n   * @type {string}\n   * @private\n  "
    " */\n  this.psaNotProcessed_ = \'\';\n\n  /**\n   * Last Index unt"
    "il incremental scripts will be executed, rest scripts will\n "
    "  * be executed after the execution of incrementalScriptsDon"
    "eCallback_.\n   * @type {!number}\n   * @private\n   */\n  this."
    "optLastIndex_ = -1;\n};\n\n/**\n * Indicates if experimental js "
    "in deferJS is active.\n * @type {boolean}\n */\ndeferJsNs.Defer"
    "Js.isExperimentalMode = false;\n\n/**\n * State Machine\n * NOT_"
    "STARTED --> SCRIPTS_REGISTERED --> SCRIPTS_EXECUTING -------"
    "---\n *                          ^                           "
    "              |\n *                          |               "
    "                          |\n *                    WAITING_FO"
    "R_NEXT_RUN <--                        |\n *                  "
    "                           \\                      |\n *      "
    "                                        \\                   "
    "  |\n * SCRIPTS_DONE <--- WAITING_FOR_ONLOAD <--- SYNC_SCRIPT"
    "S_DONE <------\n *\n * Constants for different states of defer"
    "Js exeuction.\n * @enum {number}\n */\ndeferJsNs.DeferJs.STATES"
    " = {\n  /**\n   * Start state.\n   */\n  NOT_STARTED: 0,\n  /**\n "
    "  * This state used to mark when critical scripts are done.\n"
    "   */\n  WAITING_FOR_NEXT_RUN: 1,\n  /**\n   * In this state al"
    "l script tags with type as \'text/psajs\' are registered for\n "
    "  * deferred execution.\n   */\n  SCRIPTS_REGISTERED: 2,\n  /**"
    "\n   * Script execution is in process.\n   */\n  SCRIPTS_EXECUT"
    "ING: 3,\n  /**\n   * All the sync scripts are executed but som"
    "e async scripts may not executed\n   * till now.\n   */\n  SYNC"
    "_SCRIPTS_DONE: 4,\n  /**\n   * Waiting for onload event to be "
    "triggered.\n   */\n  WAITING_FOR_ONLOAD: 5,\n  /**\n   * Final s"
    "tate.\n   */\n  SCRIPTS_DONE: 6\n};\n\n/**\n * Constants for diffe"
    "rent events used by deferJs.\n * @enum {number}\n */\ndeferJsNs"
    ".DeferJs.EVENT = {\n  /**\n   * Start event state.\n   */\n  NOT"
    "_STARTED: 0,\n  /**\n   * Event triggered before executing def"
    "erred scripts.\n   */\n  BEFORE_SCRIPTS: 1,\n  /**\n   * Event c"
    "orresponding to DOMContentLoaded.\n   */\n  DOM_READY: 2,\n  /*"
    "*\n   * Event corresponding to onload.\n   */\n  LOAD: 3,\n  /**"
    "\n   * Event triggered after executing deferred scripts.\n   *"
    "/\n  AFTER_SCRIPTS: 4\n};\n\n/**\n * Name of the attribute set fo"
    "r the nodes that are not reached so far during\n * priority s"
    "cripts execution.\n * @const {string}\n */\ndeferJsNs.DeferJs.P"
    "RIORITY_PSA_NOT_PROCESSED = \'priority_psa_not_processed\';\n\n/"
    "**\n * Name of the attribute set for the nodes that are not r"
    "eached so far during\n * scripts execution.\n * @const {string"
    "}\n */\ndeferJsNs.DeferJs.PSA_NOT_PROCESSED = \'psa_not_process"
    "ed\';\n\n/**\n * Name of the attribute set for the current node "
    "to mark the current location.\n * @const {string}\n */\ndeferJs"
    "Ns.DeferJs.PSA_CURRENT_NODE = \'psa_current_node\';\n\n/**\n * Va"
    "lue for psa dummy script nodes.\n * @const {string}\n */\ndefer"
    "JsNs.DeferJs.PSA_SCRIPT_TYPE = \'text/psajs\';\n\n/**\n * Value o"
    "f psa dummmy priority script nodes.\n * @const {string}\n */\nd"
    "eferJsNs.DeferJs.PRIORITY_PSA_SCRIPT_TYPE = \'text/priorityps"
    "ajs\';\n\n/**\n * Name of orig_type attribute in deferred script"
    " node.\n * @const {string}\n */\ndeferJsNs.DeferJs.PSA_ORIG_TYP"
    "E = \'pagespeed_orig_type\';\n\n/**\n * Name of orig_src attribut"
    "e in deferred script node.\n * @const {string}\n */\ndeferJsNs."
    "DeferJs.PSA_ORIG_SRC = \'pagespeed_orig_src\';\n\n/**\n * Name of"
    " orig_index attribute in deferred script node.\n * @const {st"
    "ring}\n */\ndeferJsNs.DeferJs.PSA_ORIG_INDEX = \'orig_index\';\n\n"
    "/**\n * Name of the deferred onload attribute.\n * @const {str"
    "ing}\n */\ndeferJsNs.DeferJs.PAGESPEED_ONLOAD = \'data-pagespee"
    "d-onload\';\n\n/**\n * Add to defer_logs if logs are enabled.\n *"
    " @param {string} line line to be added to log.\n * @param {Er"
    "ror} opt_exception optional exception to pass to log.\n */\nde"
    "ferJsNs.DeferJs.prototype.log = function(line, opt_exception"
    ") {\n  if (this.logs) {\n    this.logs.push(\'\' + line);\n    if"
    " (opt_exception) {\n      this.logs.push(opt_exception);\n    "
    "  if (typeof(console) != \'undefined\' &&\n          typeof(con"
    "sole.log) != \'undefined\') {\n        console.log(\'PSA ERROR: "
    "\' + line + opt_exception.message);\n      }\n    }\n  }\n};\n\n/**"
    "\n * Adds task to the end of queue, unless position is explic"
    "itly given.\n * @param {!function()} task Function closure to"
    " be executed later.\n * @param {number} opt_pos optional posi"
    "tion for ordering of jobs.\n */\ndeferJsNs.DeferJs.prototype.s"
    "ubmitTask = function(task, opt_pos) {\n  var pos = opt_pos ? "
    "opt_pos : this.queue_.length;\n  this.queue_.splice(pos, 0, t"
    "ask);\n};\n\n/**\n * @param {string} str to be evaluated.\n * @pa"
    "ram {Element} opt_script_elem Script element to copy attribu"
    "tes into the\n *     new script node.\n * @return {Element} Sc"
    "ript cloned element which is created.\n */\ndeferJsNs.DeferJs."
    "prototype.globalEval = function(str, opt_script_elem) {\n  va"
    "r script = this.cloneScriptNode(opt_script_elem);\n  script.t"
    "ext = str;\n  script.setAttribute(\'type\', \'text/javascript\');"
    "\n  var currentElem = this.getCurrentDomLocation();\n  current"
    "Elem.parentNode.insertBefore(script, currentElem);\n  return "
    "script;\n};\n\n/**\n * Defines a new var in the name of id\'s pre"
    "sent in the doc. This is the fix for\n * IE, where setting va"
    "lue to the var with same name as an id in the doc throws\n * "
    "exception. While creating vars, skip the names which have \'-"
    "\', \':\', \'.\'.\n * Also, variable names cannot start with digit"
    "s.\n * These characters are allowed in id names but not allow"
    "ed in variable\n * names.\n */\ndeferJsNs.DeferJs.prototype.cre"
    "ateIdVars = function() {\n  var elems = document.getElementsB"
    "yTagName(\'*\');\n  var idVarsString = \'\';\n  for (var i = 0; i "
    "< elems.length; i++) {\n    // Don\'t use elem.id since it lea"
    "ds to problem in forms.\n    if (elems[i].hasAttribute(\'id\'))"
    " {\n      var idStr = elems[i].getAttribute(\'id\');\n      if ("
    "idStr && idStr.search(/[-:.]/) == -1 &&\n          idStr.sear"
    "ch(/^[0-9]/) == -1) {\n        try {\n          if (window[idS"
    "tr] && window[idStr].tagName) {\n            idVarsString += "
    "\'var \' + idStr +\n                \'=document.getElementById(\""
    "\' + idStr + \'\");\';\n          }\n        } catch (err) {\n     "
    "     this.log(\'Exception while evaluating.\', err);\n        }"
    "\n      }\n    }\n  }\n  if (idVarsString) {\n    var script = th"
    "is.globalEval(idVarsString);\n    script.setAttribute(deferJs"
    "Ns.DeferJs.PSA_NOT_PROCESSED, \'\');\n    script.setAttribute(d"
    "eferJsNs.DeferJs.PRIORITY_PSA_NOT_PROCESSED, \'\');\n  }\n};\n\n/*"
    "*\n * Downloads all the queued Js files to prefetch without e"
    "xecuting them.\n */\ndeferJsNs.DeferJs.prototype.prefetchQueue"
    "dScripts = function() {\n  if (this.prefetchScriptsHtml_) {\n "
    "   var iframe = document.createElement(\'iframe\');\n    iframe"
    ".setAttribute(\'class\', \'psa_prefetch_container\');\n    iframe"
    ".style.display = \'none\';\n    document.body.appendChild(ifram"
    "e);\n    if (this.isFireFox()) {\n      iframe.src = \'data:tex"
    "t/html,\' +\n          encodeURIComponent(this.prefetchScripts"
    "Html_);\n    } else if (this.getIEVersion()) {\n      iframe.c"
    "ontentWindow.document.write(this.prefetchScriptsHtml_);\n    "
    "  // Close the document, else IE doesn\'t close the iframe co"
    "nnection.\n      iframe.contentWindow.document.close();\n    }"
    "\n    this.prefetchScriptsHtml_ = \'\';\n  }\n};\n\n/**\n * Tries to"
    " prefetch the file using image technique based on browser. I"
    "f it\n * can\'t queue the url to the list and will be prefetch"
    "ed when\n * prefetchQueuedScripts is called.\n * @param {!stri"
    "ng} url Url to be downloaded.\n */\ndeferJsNs.DeferJs.prototyp"
    "e.attemptPrefetchOrQueue = function(url) {\n  if (this.isWebK"
    "it()) {\n    new Image().src = url;\n  } else {\n    this.prefe"
    "tchScriptsHtml_ += \"<\" + \"script type=\'psa_prefetch\' src=\'\" "
    "+\n        url + \"\'><\\/script>\";\n  }\n};\n\n/**\n * Defers execut"
    "ion of scriptNode, by adding it to the queue.\n * @param {Ele"
    "ment} script script node.\n * @param {number} opt_pos Optiona"
    "l position for ordering.\n * @param {boolean} opt_prefetch Sc"
    "ript file is prefetched if true.\n */\ndeferJsNs.DeferJs.proto"
    "type.addNode = function(script, opt_pos, opt_prefetch) {\n  v"
    "ar src = script.getAttribute(deferJsNs.DeferJs.PSA_ORIG_SRC)"
    " ||\n      script.getAttribute(\'src\');\n  if (src) {\n    if (o"
    "pt_prefetch) {\n      this.attemptPrefetchOrQueue(src);\n    }"
    "\n    this.addUrl(src, script, opt_pos);\n  } else {\n    // ||"
    "\'ed with empty string to make sure the the value of str is n"
    "ot\n    // undefined or null.\n    var str = script.innerHTML "
    "|| script.textContent || script.data || \"\";\n    this.addStr("
    "str, script, opt_pos);\n  }\n};\n\n/**\n * Defers execution of \'s"
    "tr\', by adding it to the queue.\n * @param {!string} str vali"
    "d javascript snippet.\n * @param {Element} script_elem Psa in"
    "serted script used as context element.\n * @param {number} op"
    "t_pos Optional position for ordering.\n */\ndeferJsNs.DeferJs."
    "prototype.addStr = function(str, script_elem, opt_pos) {\n  i"
    "f (this.isFireFox()) {\n    // This is due to some bug identi"
    "fied in firefox.\n    // Got this workaround from the bug rai"
    "sed on firefox.\n    // https://bugzilla.mozilla.org/show_bug"
    ".cgi?id=728151\n    this.addUrl(\'data:text/javascript,\' + enc"
    "odeURIComponent(str),\n                script_elem,\n         "
    "       opt_pos);\n    return;\n  }\n  this.logs.push(\'Add to qu"
    "eue str: \' + str);\n  var me = this; // capture closure.\n  th"
    "is.submitTask(function() {\n    me.removeNotProcessedAttribut"
    "eTillNode(script_elem);\n\n    var node = me.nextPsaJsNode();\n"
    "    node.setAttribute(deferJsNs.DeferJs.PSA_CURRENT_NODE, \'\'"
    ");\n    try {\n      me.globalEval(str, script_elem);\n    } ca"
    "tch (err) {\n      me.log(\'Exception while evaluating.\', err)"
    ";\n    }\n    me.log(\'Evaluated: \' + str);\n    // TODO(ksimbil"
    "i): Detach stack here to prevent recursion issues.\n    me.ru"
    "nNext();\n  }, opt_pos);\n};\ndeferJsNs.DeferJs.prototype[\'addS"
    "tr\'] = deferJsNs.DeferJs.prototype.addStr;\n\n/**\n * Clones a "
    "Script Node. This is equivalent of \'cloneNode\'.\n * @param {E"
    "lement} opt_script_elem Psa inserted script used for cloning"
    " the\n *     new element.\n * @return {Element} Script Element"
    " with all attributes copied from\n *     opt_script_elem.\n */"
    "\ndeferJsNs.DeferJs.prototype.cloneScriptNode = function(opt_"
    "script_elem) {\n  var newScript = this.origCreateElement_.cal"
    "l(document, \'script\');\n  if (opt_script_elem) {\n    // Copy "
    "attributes.\n    for (var a = opt_script_elem.attributes, n ="
    " a.length, i = n - 1;\n         i >= 0; --i) {\n      // Ignor"
    "e \'type\' and \'src\' as they are set later.\n      // Ignore \'a"
    "sync\' and \'defer\', as our current.\n      // TODO(ksimbili): "
    "If a script has async then don\'t wait for it to load.\n      "
    "if (a[i].name != \'type\' && a[i].name != \'src\' &&\n          a"
    "[i].name != \'async\' && a[i].name != \'defer\' &&\n          a[i"
    "].name != deferJsNs.DeferJs.PSA_ORIG_TYPE &&\n          a[i]."
    "name != deferJsNs.DeferJs.PSA_ORIG_SRC &&\n          a[i].nam"
    "e != deferJsNs.DeferJs.PSA_ORIG_INDEX &&\n          a[i].name"
    " != deferJsNs.DeferJs.PSA_CURRENT_NODE &&\n          a[i].nam"
    "e != this.psaNotProcessed_) {\n        newScript.setAttribute"
    "(a[i].name, a[i].value);\n        opt_script_elem.removeAttri"
    "bute(a[i].name);\n      }\n    }\n  }\n  return newScript;\n};\n\n/"
    "**\n * Defers execution of contents of \'url\'.\n * @param {!str"
    "ing} url returns javascript when fetched.\n * @param {Element"
    "} script_elem Psa inserted script used as context element.\n "
    "* @param {number} opt_pos Optional position for ordering.\n *"
    "/\ndeferJsNs.DeferJs.prototype.addUrl = function(url, script_"
    "elem, opt_pos) {\n  this.logs.push(\'Add to queue url: \' + url"
    ");\n  var me = this; // capture closure.\n  this.submitTask(fu"
    "nction() {\n    me.removeNotProcessedAttributeTillNode(script"
    "_elem);\n\n    var script = me.cloneScriptNode(script_elem);\n "
    "   script.setAttribute(\'type\', \'text/javascript\');\n\n    var "
    "runNextHandler = function() {\n      me.log(\'Executed: \' + ur"
    "l);\n      me.runNext();\n    };\n    deferJsNs.addOnload(scrip"
    "t, runNextHandler);\n    deferJsNs.addHandler(script, \'error\'"
    ", runNextHandler);\n    if (me.getIEVersion() < 9) {\n      va"
    "r stateChangeHandler = function() {\n        if (script.ready"
    "State == \'complete\' ||\n            script.readyState == \'loa"
    "ded\') {\n          script.onreadystatechange = null;\n        "
    "  runNextHandler();\n        }\n      }\n\n      deferJsNs.addHa"
    "ndler(script, \'readystatechange\', stateChangeHandler);\n    }"
    "\n    script.setAttribute(\'src\', url);\n    // If a script nod"
    "e with src also has a node inside it\n    // (as innerHTML et"
    "c.), we simply create an equivalent text node so\n    // that"
    " the DOM remains the same. Note that we do not try to execut"
    "e\n    // the contents of this node.\n    var str = script_ele"
    "m.innerHTML ||\n        script_elem.textContent ||\n        sc"
    "ript_elem.data;\n    if (str) {\n      script.appendChild(docu"
    "ment.createTextNode(str));\n    }\n    var currentElem = me.ne"
    "xtPsaJsNode();\n    currentElem.setAttribute(deferJsNs.DeferJ"
    "s.PSA_CURRENT_NODE, \'\');\n    currentElem.parentNode.insertBe"
    "fore(script, currentElem);\n  }, opt_pos);\n};\ndeferJsNs.Defer"
    "Js.prototype[\'addUrl\'] = deferJsNs.DeferJs.prototype.addUrl;"
    "\n\n/**\n * Remove psaNotProcessed_ attribute till the given no"
    "de.\n * @param {Node} opt_node Stop node.\n */\ndeferJsNs.Defer"
    "Js.prototype.removeNotProcessedAttributeTillNode = function("
    "\n    opt_node) {\n  if (document.querySelectorAll && !(this.g"
    "etIEVersion() <= 8)) {\n    var nodes = document.querySelecto"
    "rAll(\n        \'[\' + this.psaNotProcessed_ + \']\');\n    for (v"
    "ar i = 0; i < nodes.length; i++) {\n      var dom_node = node"
    "s.item(i);\n      if (dom_node == opt_node) {\n        return;"
    "\n      }\n      if (dom_node.getAttribute(\'type\') != this.psa"
    "ScriptType_) {\n        dom_node.removeAttribute(this.psaNotP"
    "rocessed_);\n      }\n    }\n  }\n};\n\n/**\n * Set \'psa_not_proces"
    "sed\' attribute to all Nodes in DOM.\n */\ndeferJsNs.DeferJs.pr"
    "ototype.setNotProcessedAttributeForNodes = function() {\n  va"
    "r nodes = this.origGetElementsByTagName_.call(document, \'*\')"
    ";\n  for (var i = 0; i < nodes.length; i++) {\n    var dom_nod"
    "e = nodes.item(i);\n    dom_node.setAttribute(this.psaNotProc"
    "essed_, \'\');\n  }\n};\n\n/**\n * Get the next script psajs node t"
    "o be executed.\n * @return {Element} Element having type attr"
    "ibute set to \'text/psajs\'.\n */\ndeferJsNs.DeferJs.prototype.n"
    "extPsaJsNode = function() {\n  var current_node = null;\n  if "
    "(document.querySelector) {\n    current_node = document.query"
    "Selector(\n        \'[type=\"\' + this.psaScriptType_ + \'\"]\');\n "
    " }\n  return current_node;\n};\n\n/**\n * Get the current locatio"
    "n in DOM for the new nodes insertion. New nodes are\n * inser"
    "ted before the returned node.\n * @return {Element} Element h"
    "aving \'psa_current_node\' attribute.\n */\ndeferJsNs.DeferJs.pr"
    "ototype.getCurrentDomLocation = function() {\n  var current_n"
    "ode;\n  if (document.querySelector) {\n    current_node = docu"
    "ment.querySelector(\n        \'[\' + deferJsNs.DeferJs.PSA_CURR"
    "ENT_NODE + \']\');\n  }\n  return current_node ||\n      this.ori"
    "gGetElementsByTagName_.call(document, \'psanode\')[0];\n};\n\n/**"
    "\n * Removes the processed script node with \'text/psajs\'.\n */"
    "\ndeferJsNs.DeferJs.prototype.removeCurrentDomLocation = func"
    "tion() {\n  var oldNode = this.getCurrentDomLocation();\n  // "
    "getCurrentDomLocation can return \'psanode\' which is not a sc"
    "ript.\n  if (oldNode.nodeName == \'SCRIPT\') {\n    oldNode.pare"
    "ntNode.removeChild(oldNode);\n  }\n};\n\n/**\n * Called when the "
    "script Queue execution is finished.\n */\ndeferJsNs.DeferJs.pr"
    "ototype.onComplete = function() {\n  if (this.state_ >= defer"
    "JsNs.DeferJs.STATES.WAITING_FOR_ONLOAD) {\n    return;\n  }\n\n "
    " if (this.lastIncrementalRun_ && this.isLowPriorityDeferJs()"
    ") {\n    // ReadyState should be restored only during the las"
    "t onComplete,\n    // so that document.readyState returns \'lo"
    "ading\' till the last deferred\n    // script is executed.\n   "
    " if (this.getIEVersion() && document.documentElement[\'origin"
    "alDoScroll\']) {\n      document.documentElement.doScroll =\n  "
    "        document.documentElement[\'originalDoScroll\'];\n    }\n"
    "    if (Object.defineProperty) {\n      // Delete document.re"
    "adyState so that browser can restore it.\n      delete docume"
    "nt[\'readyState\'];\n    }\n    if (this.getIEVersion()) {\n     "
    " if (Object.defineProperty) {\n        // Delete document.all"
    " so that browser can restore it.\n        delete document[\'al"
    "l\'];\n      }\n    }\n  }\n\n  document.getElementById = this.ori"
    "gGetElementById_;\n\n  if (document.querySelectorAll && !(this"
    ".getIEVersion() <= 8)) {\n    document.getElementsByTagName ="
    " this.origGetElementsByTagName_;\n  }\n\n  document.createEleme"
    "nt = this.origCreateElement_;\n\n  document.open = this.origDo"
    "cOpen_;\n  document.close = this.origDocClose_;\n  document.wr"
    "ite = this.origDocWrite_;\n  document.writeln = this.origDocW"
    "riteln_;\n\n  if (this.lastIncrementalRun_) {\n    this.state_ "
    "= deferJsNs.DeferJs.STATES.WAITING_FOR_ONLOAD;\n\n    this.res"
    "toreAddEventListeners();\n\n    if (this.isLowPriorityDeferJs("
    ")) {\n      var me = this;\n      if (document.readyState != \'"
    "complete\') {\n        deferJsNs.addOnload(window, function() "
    "{\n          me.fireOnload();\n        });\n      } else {\n    "
    "    // Here there is a chance that window.onload is triggere"
    "d twice.\n        // But we have no way of finding this.\n    "
    "    // TODO(ksimbili): Fix the above scenario.\n        if (d"
    "ocument.onreadystatechange) {\n          this.exec(document.o"
    "nreadystatechange, document);\n        }\n        // Execute w"
    "indow.onload\n        if (window.onload) {\n          psaAddEv"
    "entListener(window, \'onload\', window.onload);\n          wind"
    "ow.onload = null;\n        }\n        this.fireOnload();\n     "
    " }\n    } else {\n      this.highPriorityFinalize();\n    }\n  }"
    " else {\n    // The following state change is only for debugg"
    "ing.\n    this.state_ = deferJsNs.DeferJs.STATES.WAITING_FOR_"
    "NEXT_RUN;\n    this.firstIncrementalRun_ = false;\n    if (thi"
    "s.incrementalScriptsDoneCallback_ && this.isLowPriorityDefer"
    "Js()) {\n      pagespeed.deferJs = pagespeed.highPriorityDefe"
    "rJs;\n      pagespeed[\'deferJs\'] = pagespeed.highPriorityDefe"
    "rJs;\n      this.exec(this.incrementalScriptsDoneCallback_);\n"
    "      this.incrementalScriptsDoneCallback_ = null;\n    } els"
    "e {\n      this.highPriorityFinalize();\n    }\n  }\n};\n\n/**\n * "
    "Fires \'onload\' event.\n */\ndeferJsNs.DeferJs.prototype.fireOn"
    "load = function() {\n  // Add all the elements whose onloads "
    "are deferred.\n  // Note, by the time we come here, all the i"
    "mages, iframes etc all should have\n  // been loaded. Because"
    " main page onload gets triggered when all it\'s\n  // resource"
    "s are loaded.So we can blindly trigger all those onloads.\n  "
    "if (this.isLowPriorityDeferJs()) {\n    this.addDeferredOnloa"
    "dListeners();\n    pagespeed.highPriorityDeferJs.fireOnload()"
    ";\n  }\n\n  this.fireEvent(deferJsNs.DeferJs.EVENT.LOAD);\n\n  if"
    " (this.isLowPriorityDeferJs()) {\n    // Clean up psanode ele"
    "ments from the DOM.\n    var psanodes = document.body.getElem"
    "entsByTagName(\'psanode\');\n    for (var i = (psanodes.length "
    "- 1); i >= 0; i--) {\n      document.body.removeChild(psanode"
    "s[i]);\n    }\n\n    // Clean up all prefetch containers we add"
    "ed.\n    var prefetchContainers =\n        document.body.getEl"
    "ementsByClassName(\'psa_prefetch_container\');\n    for (var i "
    "= (prefetchContainers.length - 1); i >= 0; i--) {\n      pref"
    "etchContainers[i].parentNode.removeChild(prefetchContainers["
    "i]);\n    }\n  }\n\n  this.state_ = deferJsNs.DeferJs.STATES.SCR"
    "IPTS_DONE;\n  this.fireEvent(deferJsNs.DeferJs.EVENT.AFTER_SC"
    "RIPTS);\n};\n\n/**\n * Finalize function for high priority scrip"
    "ts execution that start the\n * execution of low priority scr"
    "ipts.\n */\ndeferJsNs.DeferJs.prototype.highPriorityFinalize ="
    " function() {\n  var me = this;\n  window.setTimeout(function("
    ") {\n    pagespeed.deferJs = pagespeed.lowPriorityDeferJs;\n  "
    "  pagespeed[\'deferJs\'] = pagespeed.lowPriorityDeferJs;\n    i"
    "f (me.incrementalScriptsDoneCallback_) {\n      pagespeed.def"
    "erJs.registerScriptTags(\n        me.incrementalScriptsDoneCa"
    "llback_, me.optLastIndex_);\n      me.incrementalScriptsDoneC"
    "allback_ = null;\n    } else {\n      pagespeed.deferJs.regist"
    "erScriptTags();\n    }\n    pagespeed.deferJs.execute();\n  }, "
    "0);\n};\n\n/**\n * Checks if node is present in the dom.\n * @par"
    "am {Node} node Node whose presence in the dom is checked.\n *"
    " @return {boolean} returns true if node is present in the No"
    "de, false\n * otherwise.\n */\ndeferJsNs.DeferJs.prototype.chec"
    "kNodeInDom = function(node) {\n  while (node = node.parentNod"
    "e) {\n    if (node == document) {\n      return true;\n    }\n  "
    "}\n  return false;\n};\n\n/**\n * Script onload is not triggered "
    "if src is empty because such scripts\n * are not async script"
    "s as these scripts will be executed while parsing\n * the dom"
    ".\n * @param {Array.<Element>} dynamicInsertedScriptList is t"
    "he list of dynamic\n *     inserted scripts.\n * @return {numb"
    "er} returns the number of scripts whose onload will not get\n"
    " *     triggered.\n */\ndeferJsNs.DeferJs.prototype.getNumScri"
    "ptsWithNoOnload =\n    function(dynamicInsertedScriptList) {\n"
    "  var count = 0;\n  var len = dynamicInsertedScriptList.lengt"
    "h;\n  for (var i = 0; i < len; ++i) {\n    var node = dynamicI"
    "nsertedScriptList[i];\n    var parent = node.parentNode;\n    "
    "var src = node.src;\n    var text = node.textContent;\n    // "
    "IE behaves differently for async scripts compared to other b"
    "rowsers.\n    // IE triggeres script onload only if parent is"
    " not null and src or\n    // textContent is not empty. But ot"
    "her browsers trigger onload only if\n    // node is present i"
    "n the dom and src is not empty.\n    if (((this.getIEVersion("
    ") > 8) &&\n            (!parent || (src == \'\' && text == \'\'))"
    ") ||\n        (!this.getIEVersion() &&\n                (!this"
    ".checkNodeInDom(node) || src == \'\'))) {\n      count++;\n    }"
    "\n  }\n  return count;\n};\n\n/**\n *  Checks if onComplete() func"
    "tion can be called or not.\n *  @return {boolean} returns tru"
    "e if onComplete() can be called.\n */\ndeferJsNs.DeferJs.proto"
    "type.canCallOnComplete = function() {\n  // TODO(pulkitg): Ha"
    "ndle scenario where somebody sets innetHTML and references\n "
    " // in the this.dynamicInsertedScriptCount_ become invalid.\n"
    "  if (this.state_ != deferJsNs.DeferJs.STATES.SYNC_SCRIPTS_D"
    "ONE) {\n    return false;\n  }\n  var count = 0;\n  if (this.dyn"
    "amicInsertedScriptCount_ != 0) {\n    count = this.getNumScri"
    "ptsWithNoOnload(this.dynamicInsertedScript_);\n  }\n  if (this"
    ".dynamicInsertedScriptCount_ == count) {\n    return true;\n  "
    "}\n  return false;\n};\n\n/**\n * Whether all the deferred script"
    "s are done executing.\n * @return {boolean} true if all defer"
    "red scripts are done executing, false\n * otherwise.\n */\ndefe"
    "rJsNs.DeferJs.prototype.scriptsAreDone = function() {\n  retu"
    "rn this.state_ === deferJsNs.DeferJs.STATES.SCRIPTS_DONE;\n};"
    "\ndeferJsNs.DeferJs.prototype[\'scriptsAreDone\'] =\n    deferJs"
    "Ns.DeferJs.prototype.scriptsAreDone;\n\n/**\n * Schedules the n"
    "ext task in the queue.\n */\ndeferJsNs.DeferJs.prototype.runNe"
    "xt = function() {\n  this.handlePendingDocumentWrites();\n  th"
    "is.removeCurrentDomLocation();\n  if (this.next_ < this.queue"
    "_.length) {\n    // Done here to prevent another _run_next() "
    "in stack from\n    // seeing the same value of next, and get "
    "into infinite\n    // loop.\n    this.next_++;\n    this.queue_"
    "[this.next_ - 1].call(window);\n  } else {\n    if (this.lastI"
    "ncrementalRun_) {\n      this.state_ = deferJsNs.DeferJs.STAT"
    "ES.SYNC_SCRIPTS_DONE;\n      this.removeNotProcessedAttribute"
    "TillNode();\n      this.fireEvent(deferJsNs.DeferJs.EVENT.DOM"
    "_READY);\n      if (this.canCallOnComplete()) {\n        this."
    "onComplete();\n      }\n    } else {\n      this.onComplete();\n"
    "    }\n  }\n};\n\n/**\n * Converts from NodeList to array of node"
    "s.\n * @param {!NodeList} nodeList NodeList from a DOM node.\n"
    " * @return {!Array.<Node>} Array of nodes returned.\n */\ndefe"
    "rJsNs.DeferJs.prototype.nodeListToArray = function(nodeList)"
    " {\n  var arr = [];\n  var len = nodeList.length;\n  for (var i"
    " = 0; i < len; ++i) {\n    arr.push(nodeList.item(i));\n  }\n  "
    "return arr;\n};\n\n/**\n * SetUp needed before deferrred scripts"
    " execution.\n */\ndeferJsNs.DeferJs.prototype.setUp = function"
    "() {\n  var me = this;\n  if (this.firstIncrementalRun_ && !th"
    "is.isLowPriorityDeferJs()) {\n    // TODO(ksimbili): Remove t"
    "his once context is not optional.\n    // Place where documen"
    "t.write() happens if there is no context element\n    // pres"
    "ent. Happens if there is no context registering that happene"
    "d in\n    // registerNoScriptTags.\n    var initialContextNode"
    " = document.createElement(\'psanode\');\n    initialContextNode"
    ".setAttribute(\'psa_dw_target\', \'true\');\n    document.body.ap"
    "pendChild(initialContextNode);\n    if (this.getIEVersion()) "
    "{\n      this.createIdVars();\n    }\n\n    if (Object.definePro"
    "perty) {\n      try {\n        // Shadow document.readyState\n "
    "       var propertyDescriptor = { configurable: true };\n    "
    "    propertyDescriptor.get = function() {\n          return ("
    "me.state_ >= deferJsNs.DeferJs.STATES.SYNC_SCRIPTS_DONE) ?\n "
    "             \'interactive\' : \'loading\';\n        };\n        O"
    "bject.defineProperty(document, \'readyState\', propertyDescrip"
    "tor);\n      } catch (err) {\n        this.log(\'Exception whil"
    "e overriding document.readyState.\', err);\n      }\n    }\n    "
    "if (this.getIEVersion()) {\n      // In IE another approach f"
    "or identifying DOMContentLoaded is popularly\n      // used. "
    "It is described in http://javascript.nwbox.com/IEContentLoad"
    "ed/ .\n      // And JQuery is one of the libraries which empl"
    "oys this strategy.\n      document.documentElement[\'originalD"
    "oScroll\'] =\n          document.documentElement.doScroll;\n   "
    "   document.documentElement.doScroll = function() {\n        "
    "throw (\'psa exception\');\n      };\n      if (Object.definePro"
    "perty) {\n        try {\n          // Shadow document.all\n    "
    "      var propertyDescriptor = { configurable: true };\n     "
    "     propertyDescriptor.get = function() { return undefined;"
    "}\n          Object.defineProperty(document, \'all\', propertyD"
    "escriptor);\n        } catch (err) {\n          this.log(\'Exce"
    "ption while overriding document.all.\', err);\n        }\n     "
    " }\n    }\n  }\n\n  // override AddEventListeners.\n  this.overri"
    "deAddEventListeners();\n\n  // TODO(ksimbili): Restore the fol"
    "lowing functions to their original.\n  document.writeln = fun"
    "ction(x) {\n    me.writeHtml(x + \'\\n\');\n  };\n  document.write"
    " = function(x) {\n    me.writeHtml(x);\n  };\n  document.open ="
    " function() {};\n  document.close = function() {};\n\n  documen"
    "t.getElementById = function(str) {\n    me.handlePendingDocum"
    "entWrites();\n    var node = me.origGetElementById_.call(docu"
    "ment, str);\n    return node == null ||\n        node.hasAttri"
    "bute(me.psaNotProcessed_) ? null : node;\n  }\n\n  if (document"
    ".querySelectorAll && !(me.getIEVersion() <= 8)) {\n    // TOD"
    "O(ksimbili): Support IE8\n    document.getElementsByTagName ="
    " function(tagName) {\n      return document.querySelectorAll("
    "\n          tagName + \':not([\' + me.psaNotProcessed_ + \'])\');"
    "\n    }\n  }\n\n  // Overriding createElement().\n  // Attaching "
    "onload & onerror function if script node is created.\n  docum"
    "ent.createElement = function(str) {\n    var elem = me.origCr"
    "eateElement_.call(document, str);\n    if (str.toLowerCase() "
    "== \'script\') {\n      me.dynamicInsertedScript_.push(elem);\n "
    "     me.dynamicInsertedScriptCount_++;\n      var onload = fu"
    "nction() {\n        me.dynamicInsertedScriptCount_--;\n       "
    " var index = me.dynamicInsertedScript_.indexOf(this);\n      "
    "  if (index != -1) {\n          me.dynamicInsertedScript_.spl"
    "ice(index, 1);\n          if (me.canCallOnComplete()) {\n     "
    "       me.onComplete();\n          }\n        }\n      };\n     "
    " deferJsNs.addOnload(elem, onload);\n      deferJsNs.addHandl"
    "er(elem, \'error\', onload);\n    }\n    return elem;\n  }\n};\n\n/*"
    "*\n * Start the execution of the deferred script only if ther"
    "e is no async script\n * pending that was created by non defe"
    "rred.\n */\ndeferJsNs.DeferJs.prototype.execute = function() {"
    "\n  if (this.state_ != deferJsNs.DeferJs.STATES.SCRIPTS_REGIS"
    "TERED) {\n    return;\n  }\n  var count = 0;\n  if (this.noDefer"
    "AsyncScriptsCount_ != 0) {\n    count = this.getNumScriptsWit"
    "hNoOnload(this.noDeferAsyncScripts_);\n  }\n  if (this.noDefer"
    "AsyncScriptsCount_ == count) {\n    document.createElement = "
    "this.origCreateElement_;\n    this.run();\n  }\n};\ndeferJsNs.De"
    "ferJs.prototype[\'execute\'] = deferJsNs.DeferJs.prototype.exe"
    "cute;\n\n/**\n * Starts the execution of all the deferred scrip"
    "ts.\n */\ndeferJsNs.DeferJs.prototype.run = function() {\n  if "
    "(this.state_ != deferJsNs.DeferJs.STATES.SCRIPTS_REGISTERED)"
    " {\n    return;\n  }\n  if (this.firstIncrementalRun_) {\n    th"
    "is.fireEvent(deferJsNs.DeferJs.EVENT.BEFORE_SCRIPTS);\n  }\n  "
    "this.state_ = deferJsNs.DeferJs.STATES.SCRIPTS_EXECUTING;\n  "
    "this.setUp();\n  // Starts executing the defer_js closures.\n "
    " this.runNext();\n};\ndeferJsNs.DeferJs.prototype[\'run\'] = def"
    "erJsNs.DeferJs.prototype.run;\n\n/**\n * Parses the given html "
    "snippet.\n * @param {!string} html to be parsed.\n * @return {"
    "!Node} returns a DIV containing parsed nodes as children.\n *"
    "/\ndeferJsNs.DeferJs.prototype.parseHtml = function(html) {\n "
    " var div = this.origCreateElement_.call(document, \'div\');\n  "
    "// IE HACK -- Two options.\n  // 1) Either add a dummy charac"
    "ter at the start and delete it after parsing.\n  // 2) Add so"
    "me non-empty node infront of html.\n  div.innerHTML = \'<div>_"
    "</div>\' + html;\n  div.removeChild(div.firstChild);\n  return "
    "div;\n};\n\n/**\n * Removes the node from its parent if it has o"
    "ne.\n * @param {Node} node Node to be disowned from parent.\n "
    "*/\ndeferJsNs.DeferJs.prototype.disown = function(node) {\n  v"
    "ar parentNode = node.parentNode;\n  if (parentNode) {\n    par"
    "entNode.removeChild(node);\n  }\n};\n\n/**\n * Inserts all the no"
    "des before elem. It must have a parentNode for this\n * opera"
    "tion to succeed. (either actually inserted in DOM)\n * @param"
    " {!NodeList} nodes to insert.\n * @param {!Node} elem context"
    " element.\n */\ndeferJsNs.DeferJs.prototype.insertNodesBeforeE"
    "lem = function(nodes, elem) {\n  var nodeArray = this.nodeLis"
    "tToArray(nodes);\n  var len = nodeArray.length;\n  var parentN"
    "ode = elem.parentNode;\n  for (var i = 0; i < len; ++i) {\n   "
    " var node = nodeArray[i];\n    this.disown(node);\n    parentN"
    "ode.insertBefore(node, elem);\n  }\n};\n\n/**\n * Returns if the "
    "node is JavaScript Node.\n * @param {!Node} node valid script"
    " Node.\n * @return {boolean} true if script node is javascrip"
    "t node.\n */\ndeferJsNs.DeferJs.prototype.isJSNode = function("
    "node) {\n  if (node.nodeName != \'SCRIPT\') {\n    return false;"
    "\n  }\n\n  if (node.hasAttribute(\'type\')) {\n      var type = no"
    "de.getAttribute(\'type\');\n      return !type ||\n             "
    "(this.jsMimeTypes.indexOf(type) != -1);\n  } else if (node.ha"
    "sAttribute(\'language\')) {\n      var lang = node.getAttribute"
    "(\'language\');\n      return !lang ||\n             (this.jsMim"
    "eTypes.indexOf(\'text/\' + lang.toLowerCase()) != -1);\n  }\n  r"
    "eturn true;\n};\n\n/**\n * Given the list of nodes, sets the not"
    "_processed attributes to all nodes and\n * generates list of "
    "script nodes.\n * @param {!Node} node starting node for DFS.\n"
    " * @param {!Array.<Element>} scriptNodes array of script ele"
    "ments (output).\n */\ndeferJsNs.DeferJs.prototype.markNodesAnd"
    "ExtractScriptNodes = function(\n    node, scriptNodes) {\n  if"
    " (!node.childNodes) {\n    return;\n  }\n  var nodeArray = this"
    ".nodeListToArray(node.childNodes);\n  var len = nodeArray.len"
    "gth;\n  for (var i = 0; i < len; ++i) {\n    var child = nodeA"
    "rray[i];\n    // <script id=\'A\'>\n    //  command1\n    //  doc"
    "ument.write(\'<script id=\'B\'>command2<script>\');\n    //  comm"
    "and3\n    // <\\/script>\n    // Browser behaviour for above sc"
    "ript node is as follows- first execute\n    // command1 and a"
    "fter the execution of command1, scriptB starts executing\n   "
    " // and only after the complete execution of script B, comma"
    "nd3 will execute.\n    // But with deferJs turned on, after t"
    "he execution of command 1, command3\n    // gets executed and"
    " only after the complete execution of script A, script B\n   "
    " // will execute.\n    // TODO(pulkitg): Make both behaviour "
    "consistent.\n    if (child.nodeName == \'SCRIPT\') {\n      if ("
    "this.isJSNode(child)) {\n        scriptNodes.push(child);\n   "
    "     child.setAttribute(deferJsNs.DeferJs.PSA_ORIG_TYPE, chi"
    "ld.type);\n        child.setAttribute(\'type\', this.psaScriptT"
    "ype_);\n        child.setAttribute(deferJsNs.DeferJs.PSA_ORIG"
    "_SRC, child.src);\n        child.setAttribute(\'src\', \'\');\n   "
    "     child.setAttribute(this.psaNotProcessed_, \'\');\n      }\n"
    "    } else {\n      this.markNodesAndExtractScriptNodes(child"
    ", scriptNodes);\n    }\n  }\n};\n\n/**\n * @param {!Array.<Element"
    ">} scripts Array of script nodes to be deferred.\n * @param {"
    "!number} pos position for script ordering.\n */\ndeferJsNs.Def"
    "erJs.prototype.deferScripts = function(scripts, pos) {\n  var"
    " len = scripts.length;\n  for (var i = 0; i < len; ++i) {\n   "
    " this.addNode(scripts[i], pos + i, !!i);\n  }\n};\n\n/**\n * Inse"
    "rts html in the before elem, with scripts inside added to qu"
    "eue at pos.\n * @param {!string} html contains the snippet.\n "
    "* @param {!number} pos optional position to add to queue.\n *"
    " @param {Element} opt_elem optional context element.\n */\ndef"
    "erJsNs.DeferJs.prototype.insertHtml = function(html, pos, op"
    "t_elem) {\n  // Parse the html.\n  var node = this.parseHtml(h"
    "tml);\n\n  // Extract script nodes out for deferring them.\n  v"
    "ar scriptNodes = [];\n  this.markNodesAndExtractScriptNodes(n"
    "ode, scriptNodes);\n\n  // Add non-script nodes before elem\n  "
    "if (opt_elem) {\n    this.insertNodesBeforeElem(node.childNod"
    "es, opt_elem);\n  } else {\n    this.log(\'Unable to insert nod"
    "es, no context element found\');\n  }\n\n  // Add script nodes f"
    "or deferring.\n  this.deferScripts(scriptNodes, pos);\n};\n\n/**"
    "\n * Renders the document.write() buffer before the context\n "
    "* element.\n */\ndeferJsNs.DeferJs.prototype.handlePendingDocu"
    "mentWrites = function() {\n  if (this.documentWriteHtml_ == \'"
    "\') {\n    return;\n  }\n  this.log(\'handle_dw: \' + this.documen"
    "tWriteHtml_);\n\n  var html = this.documentWriteHtml_;\n  // Re"
    "set early because insertHtml may internally end up calling t"
    "his function\n  // recursively.\n  this.documentWriteHtml_ = \'"
    "\';\n\n  var currentElem = this.getCurrentDomLocation();\n  this"
    ".insertHtml(html, this.next_, currentElem);\n};\n\n/**\n * Write"
    "s html like document.write to the current context item.\n * @"
    "param {string} html Html to be written before current contex"
    "t elem.\n */\ndeferJsNs.DeferJs.prototype.writeHtml = function"
    "(html) {\n  this.log(\'dw: \' + html);\n  this.documentWriteHtml"
    "_ += html;\n};\n\n/**\n * Adds page onload event listeners to ou"
    "r own list and called them later.\n */\ndeferJsNs.DeferJs.prot"
    "otype.addDeferredOnloadListeners = function() {\n  var onload"
    "DeferredElements;\n  if (document.querySelectorAll) {\n    onl"
    "oadDeferredElements = document.querySelectorAll(\n        \'[\'"
    " + deferJsNs.DeferJs.PAGESPEED_ONLOAD + \'][data-pagespeed-lo"
    "aded]\');\n  }\n  for (var i = 0; i < onloadDeferredElements.le"
    "ngth; i++) {\n    var elem = onloadDeferredElements.item(i);\n"
    "    var handlerStr = elem.getAttribute(deferJsNs.DeferJs.PAG"
    "ESPEED_ONLOAD);\n    var functionStr = \'var psaFunc=function("
    ") {\' + handlerStr + \'};\';\n    // Define a function with the "
    "string above.\n    window[\'eval\'].call(window, functionStr);\n"
    "    if (typeof window[\'psaFunc\'] != \'function\') {\n      this"
    ".log(\'Function is not defined\', new Error(\'\'));\n      contin"
    "ue;\n    }\n\n    psaAddEventListener(elem, \'onload\', window[\'p"
    "saFunc\']);\n  }\n};\n\n/**\n * Adds functions that run as the fir"
    "st thing in run().\n * @param {!function()} func onload liste"
    "ner.\n */\ndeferJsNs.DeferJs.prototype.addBeforeDeferRunFuncti"
    "ons = function(func) {\n  psaAddEventListener(window, \'onbefo"
    "rescripts\', func);\n};\ndeferJsNs.DeferJs.prototype[\'addBefore"
    "DeferRunFunctions\'] =\n    deferJsNs.DeferJs.prototype.addBef"
    "oreDeferRunFunctions;\n\n/**\n * Adds functions that run after "
    "all the deferred scripts, DOM ready listeners\n * and onload "
    "listeners have run.\n * @param {!function()} func onload list"
    "ener.\n */\ndeferJsNs.DeferJs.prototype.addAfterDeferRunFuncti"
    "ons = function(func) {\n  psaAddEventListener(window, \'onafte"
    "rscripts\', func);\n};\ndeferJsNs.DeferJs.prototype[\'addAfterDe"
    "ferRunFunctions\'] =\n    deferJsNs.DeferJs.prototype.addAfter"
    "DeferRunFunctions;\n\n/**\n * Firing event will execute all lis"
    "teners registered for the event.\n * @param {!deferJsNs.Defer"
    "Js.EVENT.<number>} evt Event to be fired.\n */\ndeferJsNs.Defe"
    "rJs.prototype.fireEvent = function(evt) {\n  this.eventState_"
    " = evt;\n  this.log(\'Firing Event: \' + evt);\n  var eventListe"
    "ners = this.eventListernersMap_[evt] || [];\n  for (var i = 0"
    "; i < eventListeners.length; ++i) {\n    this.exec(eventListe"
    "ners[i]);\n  }\n  eventListeners.length = 0;\n};\n\n/**\n * Execut"
    "e function under try catch.\n * @param {!function()} func Fun"
    "ction to be executed.\n * @param {Window|Element|Document} op"
    "t_scopeObject Element to be used as scope.\n */\ndeferJsNs.Def"
    "erJs.prototype.exec = function(func, opt_scopeObject) {\n  tr"
    "y {\n    func.call(opt_scopeObject || window);\n  } catch (err"
    ") {\n    this.log(\'Exception while evaluating.\', err);\n  }\n};"
    "\n\n/**\n * Override native event registration function on wind"
    "ow and document objects.\n */\ndeferJsNs.DeferJs.prototype.ove"
    "rrideAddEventListeners = function() {\n  var me = this;\n  // "
    "override AddEventListeners.\n  if (window.addEventListener) {"
    "\n    document.addEventListener = function(eventName, func, c"
    "apture) {\n      psaAddEventListener(document, eventName, fun"
    "c, capture,\n                          me.origDocAddEventList"
    "ener_);\n    }\n    window.addEventListener = function(eventNa"
    "me, func, capture) {\n      psaAddEventListener(window, event"
    "Name, func, capture,\n                          me.origWindow"
    "AddEventListener_);\n    }\n  } else if (window.attachEvent) {"
    "\n    document.attachEvent = function(eventName, func) {\n    "
    "  psaAddEventListener(document, eventName, func, undefined,\n"
    "                          me.origDocAttachEvent_);\n    }\n   "
    " window.attachEvent = function(eventName, func) {\n      psaA"
    "ddEventListener(window, eventName, func, undefined,\n        "
    "                  me.origWindowAttachEvent_);\n    }\n  }\n};\n\n"
    "/**\n * Restore native event registration functions on window"
    " and document.\n */\ndeferJsNs.DeferJs.prototype.restoreAddEve"
    "ntListeners = function() {\n  if (window.addEventListener) {\n"
    "    document.addEventListener = this.origDocAddEventListener"
    "_;\n    window.addEventListener = this.origWindowAddEventList"
    "ener_;\n  } else if (window.attachEvent) {\n    document.attac"
    "hEvent = this.origDocAttachEvent_;\n    window.attachEvent = "
    "this.origWindowAttachEvent_;\n  }\n};\n\n/**\n * Registers an eve"
    "nt with the element.\n * @param {!(Window|Node|Document)} ele"
    "m Element which is registering for the\n * event.\n * @param {"
    "!string} eventName Name of the event.\n * @param {(Function|E"
    "ventListener|function())} func Event handler.\n * @param {boo"
    "lean} opt_capture Capture event.\n * @param {Function} opt_or"
    "iginalAddEventListener Original Add event Listener\n * funcit"
    "on.\n */\nvar psaAddEventListener = function(elem, eventName, "
    "func, opt_capture,\n                                   opt_or"
    "iginalAddEventListener) {\n  var deferJs = pagespeed[\'deferJs"
    "\'];\n  if (deferJs.state_ >= deferJsNs.DeferJs.STATES.SCRIPTS"
    "_DONE) {\n    return;\n  }\n  var deferJsEvent;\n\n  if (deferJs."
    "eventState_ < deferJsNs.DeferJs.EVENT.DOM_READY &&\n     (eve"
    "ntName == \'DOMContentLoaded\' || eventName == \'readystatechan"
    "ge\' ||\n      eventName == \'onDOMContentLoaded\' || eventName "
    "== \'onreadystatechange\')) {\n    deferJsEvent = deferJsNs.Def"
    "erJs.EVENT.DOM_READY;\n  } else if (deferJs.eventState_ < def"
    "erJsNs.DeferJs.EVENT.LOAD &&\n            (eventName == \'load"
    "\' || eventName == \'onload\')) {\n    deferJsEvent = deferJsNs."
    "DeferJs.EVENT.LOAD;\n  } else if (eventName == \'onbeforescrip"
    "ts\') {\n    deferJsEvent = deferJsNs.DeferJs.EVENT.BEFORE_SCR"
    "IPTS;\n  } else if (eventName == \'onafterscripts\') {\n    defe"
    "rJsEvent = deferJsNs.DeferJs.EVENT.AFTER_SCRIPTS;\n  } else {"
    "\n    if (opt_originalAddEventListener) {\n      opt_originalA"
    "ddEventListener.call(elem, eventName, func, opt_capture);\n  "
    "  }\n    return;\n  }\n  var loadEvent;\n  // TODO(ksimbili): Fi"
    "x for IE8 too.\n  if (deferJsEvent == deferJsNs.DeferJs.EVENT"
    ".LOAD &&\n      !(deferJs.getIEVersion() <= 8)) {\n    // HACK"
    " HACK: This is specifically to solve for jquery libraries, w"
    "ho try\n    // to read the event being passed.\n    // Note we"
    " are not setting any of the other params in event. We don\'t "
    "see\n    // them as a need for now.\n    loadEvent = document."
    "createEvent(\'HTMLEvents\');\n    loadEvent.initEvent(\'load\', f"
    "alse, false);\n  }\n\n  var eventListenerClosure = function() {"
    "\n    func.call(elem, loadEvent);\n  }\n  if (!deferJs.eventLis"
    "ternersMap_[deferJsEvent]) {\n    deferJs.eventListernersMap_"
    "[deferJsEvent] = [];\n  }\n  deferJs.eventListernersMap_[defer"
    "JsEvent].push(\n      eventListenerClosure);\n};\n\n/**\n * Regis"
    "ters all script tags which are marked text/psajs, by adding "
    "themselves\n * as the context element to the script embedded "
    "inside them.\n * @param {function()} opt_callback Called when"
    " critical scripts are\n *     done executing.\n * @param {numb"
    "er} opt_last_index till where its safe to run scripts.\n */\nd"
    "eferJsNs.DeferJs.prototype.registerScriptTags = function(\n  "
    "opt_callback, opt_last_index) {\n  if (this.state_ >= deferJs"
    "Ns.DeferJs.STATES.SCRIPTS_REGISTERED) {\n    return;\n  }\n  if"
    " (opt_callback) {\n    if (!deferJsNs.DeferJs.isExperimentalM"
    "ode) {\n      opt_callback();\n      return;\n    }\n    this.la"
    "stIncrementalRun_ = false;\n    this.incrementalScriptsDoneCa"
    "llback_ = opt_callback;\n    if (opt_last_index) {\n      this"
    ".optLastIndex_ = opt_last_index;\n    }\n  } else {\n    this.l"
    "astIncrementalRun_ = true;\n  }\n\n  this.state_ = deferJsNs.De"
    "ferJs.STATES.SCRIPTS_REGISTERED;\n  var scripts = document.ge"
    "tElementsByTagName(\'script\');\n  var len = scripts.length;\n  "
    "for (var i = 0; i < len; ++i) {\n    var isFirstScript = (thi"
    "s.queue_.length == this.next_);\n    var script = scripts[i];"
    "\n    // TODO(ksimbili): Use orig_type\n    if (script.getAttr"
    "ibute(\'type\') == this.psaScriptType_) {\n      if (opt_callba"
    "ck) {\n        var scriptIndex =\n            script.getAttrib"
    "ute(deferJsNs.DeferJs.PSA_ORIG_INDEX);\n        if (scriptInd"
    "ex <= this.optLastIndex_) {\n          this.addNode(script, u"
    "ndefined, !isFirstScript);\n        }\n      } else {\n        "
    "if (script.getAttribute(deferJsNs.DeferJs.PSA_ORIG_INDEX) <\n"
    "            this.optLastIndex_) {\n          this.log(\'Execut"
    "ing a script twice. Orig_Index: \' +\n                   scrip"
    "t.getAttribute(deferJsNs.DeferJs.PSA_ORIG_INDEX),\n          "
    "         new Error(\'\'));\n        }\n        this.addNode(scri"
    "pt, undefined, !isFirstScript);\n      }\n    }\n  }\n  this.pre"
    "fetchQueuedScripts();\n};\ndeferJsNs.DeferJs.prototype[\'regist"
    "erScriptTags\'] =\n    deferJsNs.DeferJs.prototype.registerScr"
    "iptTags;\n\n/**\n * Runs the function when element is loaded.\n "
    "* @param {Window|Element} elem Element to attach handler.\n *"
    " @param {!function()} func New onload handler.\n */\ndeferJsNs"
    ".addOnload = function(elem, func) {\n  deferJsNs.addHandler(e"
    "lem, \'load\', func);\n};\npagespeed[\'addOnload\'] = deferJsNs.ad"
    "dOnload;\n\n/**\n * Runs the function when event is triggered.\n"
    " * @param {HTMLDocument|Window|Element} elem Element to atta"
    "ch handler.\n * @param {!string} eventName Name of the event."
    "\n * @param {!function()} func New onload handler.\n */\ndeferJ"
    "sNs.addHandler = function(elem, eventName, func) {\n  if (ele"
    "m.addEventListener) {\n    elem.addEventListener(eventName, f"
    "unc, false);\n  } else if (elem.attachEvent) {\n    elem.attac"
    "hEvent(\'on\' + eventName, func);\n  } else {\n    var oldHandle"
    "r = elem[\'on\' + eventName];\n    elem[\'on\' + eventName] = fun"
    "ction() {\n      func.call(this);\n      if (oldHandler) {\n   "
    "     oldHandler.call(this);\n      }\n    }\n  }\n};\npagespeed[\'"
    "addHandler\'] = deferJsNs.addHandler;\n\n/**\n * @return {boolea"
    "n} true if browser is Firefox.\n */\ndeferJsNs.DeferJs.prototy"
    "pe.isFireFox = function() {\n  return (navigator.userAgent.in"
    "dexOf(\'Firefox\') != -1);\n};\n\n/**\n * @return {boolean} true i"
    "f browser is WebKit based.\n */\ndeferJsNs.DeferJs.prototype.i"
    "sWebKit = function() {\n  return (navigator.userAgent.indexOf"
    "(\'AppleWebKit\') != -1);\n};\n\n/**\n * @return {number} version "
    "number if browser is IE.\n */\ndeferJsNs.DeferJs.prototype.get"
    "IEVersion = function() {\n  var version = /(?:MSIE.(\\d+\\.\\d+)"
    ")/.exec(navigator.userAgent);\n  return (version && version[1"
    "]) ?\n         (document.documentMode || parseFloat(version[1"
    "])) :\n         NaN;\n};\n\n/**\n * Set the type of the scripts w"
    "hich will be executed.\n * @param {string} type of psa dummy "
    "nodes that need to be processed.\n */\ndeferJsNs.DeferJs.proto"
    "type.setType = function(type) {\n  this.psaScriptType_ = type"
    ";\n};\n\n/**\n * Set the psaNotProcessed marker.\n * @param {stri"
    "ng} psaNotProcessed marker.\n */\ndeferJsNs.DeferJs.prototype."
    "setPsaNotProcessed = function(psaNotProcessed) {\n  this.psaN"
    "otProcessed_ = psaNotProcessed;\n};\n\n/**\n * Whether defer jav"
    "ascript is executing low priority scripts.\n * @return {boole"
    "an} returns true if defer javascript is executing low priori"
    "ty\n *     scripts.\n */\ndeferJsNs.DeferJs.prototype.isLowPrio"
    "rityDeferJs = function() {\n  if (this.psaScriptType_ == defe"
    "rJsNs.DeferJs.PSA_SCRIPT_TYPE) {\n    return true;\n  }\n  retu"
    "rn false;\n};\n\n/**\n * Overrides createElement for the non-def"
    "erred scripts. Any async script\n * created by non-deferred s"
    "cript should be executed before deferred scripts\n * gets exe"
    "cuted.\n */\ndeferJsNs.DeferJs.prototype.noDeferCreateElementO"
    "verride = function() {\n  // Attaching onload & onerror funct"
    "ion if script node is created.\n  var me = this;\n  document.c"
    "reateElement = function(str) {\n    var elem = me.origCreateE"
    "lement_.call(document, str);\n    if (str.toLowerCase() == \'s"
    "cript\') {\n      me.noDeferAsyncScripts_.push(elem);\n      me"
    ".noDeferAsyncScriptsCount_++;\n      var onload = function() "
    "{\n        var index = me.noDeferAsyncScripts_.indexOf(this);"
    "\n        if (index != -1) {\n          me.noDeferAsyncScripts"
    "_.splice(index, 1);\n          me.noDeferAsyncScriptsCount_--"
    ";\n          me.execute();\n        }\n      };\n      deferJsNs"
    ".addOnload(elem, onload);\n      deferJsNs.addHandler(elem, \'"
    "error\', onload);\n    }\n    return elem;\n  }\n};\n\n/**\n * @retu"
    "rn {boolean} true if deferJs is running with experimental fl"
    "ag.\n */\ndeferJsNs.DeferJs.prototype.isExperimentalMode = fun"
    "ction() {\n  return deferJsNs.DeferJs.isExperimentalMode;\n};\n"
    "deferJsNs.DeferJs.prototype[\'isExperimentalMode\'] =\n    defe"
    "rJsNs.DeferJs.prototype.isExperimentalMode;\n\n/**\n * Initiali"
    "ze defer javascript.\n */\ndeferJsNs.deferInit = function() {\n"
    "  if (pagespeed[\'deferJs\']) {\n    return;\n  }\n\n  if (window."
    "localStorage) {\n    deferJsNs.DeferJs.isExperimentalMode =\n "
    "       window.localStorage[\'defer_js_experimental\'];\n  }\n\n  "
    "pagespeed.highPriorityDeferJs = new deferJsNs.DeferJs();\n  p"
    "agespeed.highPriorityDeferJs.setType(\n    deferJsNs.DeferJs."
    "PRIORITY_PSA_SCRIPT_TYPE);\n  pagespeed.highPriorityDeferJs.s"
    "etPsaNotProcessed(\n    deferJsNs.DeferJs.PRIORITY_PSA_NOT_PR"
    "OCESSED);\n  pagespeed.highPriorityDeferJs.setNotProcessedAtt"
    "ributeForNodes();\n  pagespeed.lowPriorityDeferJs = new defer"
    "JsNs.DeferJs();\n  pagespeed.lowPriorityDeferJs.setType(defer"
    "JsNs.DeferJs.PSA_SCRIPT_TYPE);\n  pagespeed.lowPriorityDeferJ"
    "s.setPsaNotProcessed(\n    deferJsNs.DeferJs.PSA_NOT_PROCESSE"
    "D);\n  pagespeed.lowPriorityDeferJs.setNotProcessedAttributeF"
    "orNodes();\n  pagespeed.deferJs = pagespeed.highPriorityDefer"
    "Js;\n\n  pagespeed.deferJs.noDeferCreateElementOverride();\n  p"
    "agespeed[\'deferJs\'] = pagespeed.deferJs;\n};\n\ndeferJsNs.defer"
    "Init();\n\n/**\n * Indicates if deferJs started executing.\n * @"
    "type {boolean}\n */\npagespeed.deferJsStarted = false;\n\n/**\n *"
    " Starts deferJs execution.\n */\ndeferJsNs.startDeferJs = func"
    "tion() {\n  if (pagespeed.deferJsStarted || pagespeed[\'panelL"
    "oader\']) return;\n  pagespeed.deferJsStarted = true;\n  pagesp"
    "eed.deferJs.registerScriptTags();\n  pagespeed.deferJs.execut"
    "e();\n};\ndeferJsNs[\'startDeferJs\'] = deferJsNs.startDeferJs;\n"
    "deferJsNs.addHandler(document, \'DOMContentLoaded\', deferJsNs"
    ".startDeferJs);\ndeferJsNs.addOnload(window, deferJsNs.startD"
    "eferJs);\n";

}  // namespace net_instaweb
