// Copyright 2011 Google Inc. All Rights Reserved.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Automatically generated from ../../net/instaweb/rewriter/lazyload_images.js

namespace net_instaweb {

const char* JS_lazyload_images =
    "/*\n * Copyright 2011 Google Inc.\n *\n * Licensed under the Ap"
    "ache License, Version 2.0 (the \"License\");\n * you may not us"
    "e this file except in compliance with the License.\n * You ma"
    "y obtain a copy of the License at\n *\n *      http://www.apac"
    "he.org/licenses/LICENSE-2.0\n *\n * Unless required by applica"
    "ble law or agreed to in writing, software\n * distributed und"
    "er the License is distributed on an \"AS IS\" BASIS,\n * WITHOU"
    "T WARRANTIES OR CONDITIONS OF ANY KIND, either express or im"
    "plied.\n * See the License for the specific language governin"
    "g permissions and\n * limitations under the License.\n */\n\n/**"
    "\n * @fileoverview Code for lazy loading images on the client"
    " side.\n * This javascript is part of LazyloadImages filter.\n"
    " *\n * @author nikhilmadan@google.com (Nikhil Madan)\n */\n\n// "
    "Exporting functions using quoted attributes to prevent js co"
    "mpiler from\n// renaming them.\n// See http://code.google.com/"
    "closure/compiler/docs/api-tutorial3.html#dangers\nwindow[\'pag"
    "espeed\'] = window[\'pagespeed\'] || {};\nvar pagespeed = window"
    "[\'pagespeed\'];\n\n/**\n * @constructor\n * @param {string} blank"
    "ImageSrc The blank placeholder image used for images\n *     "
    "that are not visible.\n */\npagespeed.LazyloadImages = functio"
    "n(blankImageSrc) {\n  /**\n   * Array of images that have been"
    " deferred.\n   * @type {Array.<Element>}\n   * @private\n   */\n"
    "  this.deferred_ = [];\n\n  /**\n   * The number of additional "
    "pixels above or below the current viewport\n   * within which"
    " to fetch images. This can be configured for producing a\n   "
    "* smoother experience for the user while scrolling down by f"
    "etching images\n   * just outside the current viewport. Shoul"
    "d be a positive number.\n   * @type {number}\n   * @private\n  "
    " */\n  this.buffer_ = 0;\n\n  /**\n   * Boolean indicating wheth"
    "er we should force loading of all images,\n   * irrespective "
    "of whether or not they are visible. This is set to true when"
    "\n   * we want to load all images after onload is triggered.\n"
    "   * @type {boolean}\n   * @private\n   */\n  this.force_load_ "
    "= false;\n\n  /**\n   * The blank placeholder image used for im"
    "ages that are not visible.\n   * @type {string}\n   * @private"
    "\n   */\n  this.blank_image_src_ = blankImageSrc;\n\n  /**\n   * "
    "The ID of the event that is currently scheduled to be trigge"
    "red to detect\n   * and display visible images.\n   * @private"
    "\n   */\n  this.scroll_timer_ = null;\n\n  /**\n   * The time the"
    " last scroll event was fired in milliseconds since epoch.\n  "
    " * @type {number}\n   * @private\n   */\n  this.last_scroll_tim"
    "e_ = 0;\n\n  /**\n   * The minimum time in milliseconds between"
    " two scroll events being fired.\n   * @type {number}\n   * @pr"
    "ivate\n   */\n  this.min_scroll_time_ = 200;\n\n  /**\n   * Boole"
    "an indicating whether the onload of the page has been trigge"
    "red.\n   * @type {boolean}\n   * @private\n   */\n  this.onload_"
    "done_ = false;\n};\n\n/**\n * Returns a bounding box for the cur"
    "rently visible part of the window.\n * @return {{\n *     top:"
    " (number),\n *     bottom: (number),\n *     height: (number)\n"
    " * }}\n * @private\n */\npagespeed.LazyloadImages.prototype.vie"
    "wport_ = function() {\n  var scrollY = 0;\n  if (typeof(window"
    ".pageYOffset) == \'number\') {\n    scrollY = window.pageYOffse"
    "t;\n  } else if (document.body && document.body.scrollTop) {\n"
    "    scrollY = document.body.scrollTop;\n  } else if (document"
    ".documentElement && document.documentElement.scrollTop) {\n  "
    "  scrollY = document.documentElement.scrollTop;\n  }\n  var he"
    "ight = window.innerHeight || document.documentElement.client"
    "Height ||\n      document.body.clientHeight;\n  return {\n    t"
    "op: scrollY,\n    bottom: scrollY + height,\n    height: heigh"
    "t\n  };\n};\n\n/**\n * Returns the position of the top of the giv"
    "en element with respect to the top\n * of the page.\n * @param"
    " {Element} element DOM element to measure offset of.\n * @ret"
    "urn {number} The position of the element in the page.\n * @pr"
    "ivate\n */\npagespeed.LazyloadImages.prototype.compute_top_ = "
    "function(element) {\n  var position = element.getAttribute(\'p"
    "agespeed_lazy_position\');\n  if (position) {\n    return parse"
    "Int(position, 0);\n  }\n  position = element.offsetTop;\n  var "
    "parent = element.offsetParent;\n  if (parent) {\n    position "
    "+= this.compute_top_(parent);\n  }\n  // Since position is abs"
    "olute, it should always be >= 0.\n  position = Math.max(posit"
    "ion, 0);\n  element.setAttribute(\'pagespeed_lazy_position\', p"
    "osition);\n  return position;\n};\n\n/**\n * Returns a bounding b"
    "ox for the given element.\n * @param {Element} element DOM el"
    "ement whose position is to be computed.\n * @return {{\n *    "
    " top: (number),\n *     bottom: (number)\n * }}\n * @private\n *"
    "/\npagespeed.LazyloadImages.prototype.offset_ = function(elem"
    "ent) {\n  var top_position = this.compute_top_(element);\n  re"
    "turn {\n    top: top_position,\n    bottom: top_position + ele"
    "ment.offsetHeight\n  };\n};\n\n/**\n * Returns the value of the g"
    "iven style property for the element.\n * @param {Element} ele"
    "ment DOM element whose style property is to be computed.\n * "
    "@param {string} property The CSS property we are trying to f"
    "ind.\n * @return {string} The given property if found, and em"
    "pty string otherwise.\n * @private\n */\npagespeed.LazyloadImag"
    "es.prototype.getStyle_ = function(element, property) {\n  if "
    "(element.currentStyle) {\n    // IE.\n    return element.curre"
    "ntStyle[property];\n  }\n  if (document.defaultView &&\n      d"
    "ocument.defaultView.getComputedStyle) {\n    // Other browser"
    "s.\n    var style = document.defaultView.getComputedStyle(ele"
    "ment, null);\n    if (style) {\n      return style.getProperty"
    "Value(property);\n    }\n  }\n  if (element.style && element.st"
    "yle[property]) {\n    return element.style[property];\n  }\n  /"
    "/ Fallback.\n  return \'\';\n};\n\n/**\n * Returns true if an eleme"
    "nt is currently visible or within the buffer.\n * @param {Ele"
    "ment} element The DOM element to check for visibility.\n * @r"
    "eturn {boolean} True if the element is visible.\n * @private\n"
    " */\npagespeed.LazyloadImages.prototype.isVisible_ = function"
    "(element) {\n  var element_position = this.getStyle_(element,"
    " \'position\');\n  if (element_position == \'relative\') {\n    //"
    " TODO(ksimbili): Check if this code is still needed. Find ou"
    "t if any other\n    // alterntive will solve this.\n    // If "
    "the element contains a \"position: relative\" style attribute,"
    " assume\n    // it is visible since getBoundingClientRect() d"
    "oesn\'t seem to work\n    // correctly here.\n    return true;\n"
    "  }\n\n  if (!this.onload_done_ &&\n      (element.offsetHeight"
    " == 0 || element.offsetWidth == 0)) {\n    // The element is "
    "most likely hidden.\n    // Since we don\'t know when the elem"
    "ent will become visible, we\'ll try to\n    // load the image "
    "after onload, so that we can improve PLT.\n    return false;\n"
    "  }\n  var viewport = this.viewport_();\n  var rect = element."
    "getBoundingClientRect();\n  var top_diff, bottom_diff;\n  if ("
    "rect) {\n    // getBoundingClientRect() gives the position wi"
    "th respect to the current\n    // viewport.\n    top_diff = re"
    "ct.top - viewport.height;\n    bottom_diff = rect.bottom;\n  }"
    " else {\n    var position = this.offset_(element);\n    top_di"
    "ff = position.top - viewport.bottom;\n    bottom_diff = posit"
    "ion.bottom - viewport.top;\n  }\n  return (top_diff <= this.bu"
    "ffer_ &&\n          bottom_diff + this.buffer_ >= 0);\n};\n\n/**"
    "\n * Loads the given element if it is visible. Otherwise, add"
    "s it to the deferred\n * queue. Note that if force_load_ is t"
    "rue, the visibility check is skipped.\n * @param {Element} el"
    "ement The element to check for visibility.\n */\npagespeed.Laz"
    "yloadImages.prototype.loadIfVisible = function(element) {\n  "
    "// Override this element\'s attributes if they haven\'t alread"
    "y been overridden.\n  this.overrideAttributeFunctionsInternal"
    "_(element);\n\n  var context = this;\n  window.setTimeout(funct"
    "ion() {\n    var data_src = element.getAttribute(\'pagespeed_l"
    "azy_src\');\n    if (data_src != null) {\n      if ((context.fo"
    "rce_load_ || context.isVisible_(element)) &&\n          eleme"
    "nt.src.indexOf(context.blank_image_src_ != -1)) {\n        //"
    " Only replace the src if the old value is the one we set. No"
    "te that we\n        // do a \'contains\' match to handle the ca"
    "se when the blank src is a url\n        // starting with //. "
    "It is possible that a script has already changed\n        // "
    "the url, in which case, we should not modify it.\n        // "
    "Remove the element from the DOM and and add it back in, sinc"
    "e simply\n        // setting the src doesn\'t seem to always w"
    "ork in chrome.\n        var parent_node = element.parentNode;"
    "\n        var next_sibling = element.nextSibling;\n        if "
    "(parent_node) {\n          parent_node.removeChild(element);\n"
    "        }\n\n        // Restore the old functions.\n        ele"
    "ment.getAttribute = element._getAttribute;\n        // Remove"
    " attributes that are no longer needed.\n        element.remov"
    "eAttribute(\'onload\');\n        element.removeAttribute(\'pages"
    "peed_lazy_src\');\n        element.removeAttribute(\'pagespeed_"
    "lazy_replaced_functions\');\n        // If there was a next si"
    "bling, insert element before it.\n        if (parent_node) {\n"
    "          parent_node.insertBefore(element, next_sibling);\n "
    "       }\n        // Set the src back to the original.\n      "
    "  element.src = data_src;\n      } else {\n        context.def"
    "erred_.push(element);\n      }\n    }\n  }, 0);\n};\n\npagespeed.L"
    "azyloadImages.prototype[\'loadIfVisible\'] =\n    pagespeed.Laz"
    "yloadImages.prototype.loadIfVisible;\n\n/**\n * Loads all the i"
    "mages irrespective of whether or not they are in the\n * view"
    "port.\n */\npagespeed.LazyloadImages.prototype.loadAllImages ="
    " function() {\n  this.force_load_ = true;\n  this.loadVisible_"
    "();\n};\n\npagespeed.LazyloadImages.prototype[\'loadAllImages\'] "
    "=\n    pagespeed.LazyloadImages.prototype.loadAllImages;\n\n/**"
    "\n * Loads the visible elements in the deferred queue. Also, "
    "removes the loaded\n * elements from the deferred queue.\n * @"
    "private\n */\npagespeed.LazyloadImages.prototype.loadVisible_ "
    "= function() {\n  var old_deferred = this.deferred_;\n  var le"
    "n = old_deferred.length;\n  this.deferred_ = [];\n  for (var i"
    " = 0; i < len; ++i) {\n    this.loadIfVisible(old_deferred[i]"
    ");\n  }\n};\n\n/**\n * Returns true if the given element has an a"
    "ttribute with the given name.\n * @param {Element} element Th"
    "e element whose attributes we are checking.\n * @param {strin"
    "g} attribute The attribute we are checking for.\n * @return {"
    "boolean} True if the element has the given attribute.\n * @pr"
    "ivate\n */\npagespeed.LazyloadImages.prototype.hasAttribute_ ="
    "\n    function(element, attribute) {\n  if (element.getAttribu"
    "te_) {\n    return element.getAttribute_(attribute) != null;\n"
    "  }\n  return element.getAttribute(attribute) != null;\n};\n\n/*"
    "*\n * Overrides attribute functions for all lazily loaded ima"
    "ges if they have not\n * already been overridden.\n */\npagespe"
    "ed.LazyloadImages.prototype.overrideAttributeFunctions = fun"
    "ction() {\n  var images = document.getElementsByTagName(\'img\'"
    ");\n  for (var i = 0; i < images.length; ++i) {\n    var eleme"
    "nt = images[i];\n    if (this.hasAttribute_(element, \'pagespe"
    "ed_lazy_src\')) {\n      this.overrideAttributeFunctionsIntern"
    "al_(element);\n    }\n  }\n};\n\npagespeed.LazyloadImages.prototy"
    "pe[\'overrideAttributeFunctions\'] =\n    pagespeed.LazyloadIma"
    "ges.prototype.overrideAttributeFunctions;\n\n/**\n * Overrides "
    "attribute functions for the given image if they have not alr"
    "eady\n * been overridden.\n * @param {Element} element The ele"
    "ment whose attribute functions should be\n *     overridden.\n"
    " * @private\n */\npagespeed.LazyloadImages.prototype.overrideA"
    "ttributeFunctionsInternal_ =\n    function(element) {\n  var c"
    "ontext = this;\n  if (!this.hasAttribute_(element, \'pagespeed"
    "_lazy_replaced_functions\')) {\n    element._getAttribute = el"
    "ement.getAttribute;\n    element.getAttribute = function(name"
    ") {\n      if (name.toLowerCase() == \'src\' &&\n          conte"
    "xt.hasAttribute_(this, \'pagespeed_lazy_src\')) {\n        name"
    " = \'pagespeed_lazy_src\';\n      }\n      return this._getAttri"
    "bute(name);\n    };\n    element.setAttribute(\'pagespeed_lazy_"
    "replaced_functions\', \'1\');\n  }\n};\n\n/**\n * Runs the function "
    "when event is triggered.\n * @param {Window|Element} elem Ele"
    "ment to attach handler.\n * @param {string} ev Name of the ev"
    "ent.\n * @param {function()} func New onload handler.\n *\n * T"
    "ODO(nikhilmadan): Avoid duplication with the DeferJs code.\n "
    "*/\npagespeed.addHandler = function(elem, ev, func) {\n  if (e"
    "lem.addEventListener) {\n    elem.addEventListener(ev, func, "
    "false);\n  } else if (elem.attachEvent) {\n    elem.attachEven"
    "t(\'on\' + ev, func);\n  } else {\n    var oldHandler = elem[\'on"
    "\' + ev];\n    elem[\'on\' + ev] = function() {\n      func.call("
    "this);\n      if (oldHandler) {\n        oldHandler.call(this)"
    ";\n      }\n    };\n  }\n};\n\n/**\n * Initializes the lazyload mod"
    "ule.\n * @param {boolean} loadAfterOnload If true, load image"
    "s when the onload event.\n * @param {string} blankImageSrc Th"
    "e blank placeholder image used for images\n *     that are no"
    "t visible.\n * is fired. Otherwise, load images on scrolling "
    "as they become visible.\n */\npagespeed.lazyLoadInit = functio"
    "n(loadAfterOnload, blankImageSrc) {\n  var context = new page"
    "speed.LazyloadImages(blankImageSrc);\n  pagespeed[\'lazyLoadIm"
    "ages\'] = context;\n  // Add an event to the onload handler to"
    " check if any new images have now\n  // become visible becaus"
    "e of reflows or DOM manipulation. If loadAfterOnload\n  // is"
    " true, load all images on the page.\n  var lazy_onload = func"
    "tion() {\n    context.onload_done_ = true;\n    // Note that t"
    "he timeout here should be greater than the timeout for the\n "
    "   // delay_images filter to avoid CPU contention between th"
    "e two filters.\n    window.setTimeout(function() {\n      cont"
    "ext.force_load_ = loadAfterOnload;\n      context.loadVisible"
    "_();\n    }, 200);\n  };\n  if (blankImageSrc.indexOf(\'data\') !"
    "= 0) {\n    new Image().src = blankImageSrc;\n  }\n  pagespeed."
    "addHandler(window, \'load\', lazy_onload);\n  if (!loadAfterOnl"
    "oad) {\n    // NOTE: We don\'t delay any scroll event by great"
    "er than min_scroll_time_.\n    var lazy_onscroll = function()"
    " {\n      if (!context.scroll_timer_) {\n        // Check that"
    " a scroll_timer_ has not been attached already.\n        var "
    "now = new Date().getTime();\n        var timeout_ms = context"
    ".min_scroll_time_;\n        if (now - context.last_scroll_tim"
    "e_ > context.min_scroll_time_) {\n          // If the time si"
    "nce the last scroll is greater than min_scroll_time_,\n      "
    "    // load visible images immediately.\n          timeout_ms"
    " = 0;\n        }\n        // Otherwise, load images after min_"
    "scroll_time_.\n        context.scroll_timer_ = window.setTime"
    "out(function() {\n          context.last_scroll_time_ = new D"
    "ate().getTime();\n          context.loadVisible_();\n         "
    " context.scroll_timer_ = null;\n        }, timeout_ms);\n     "
    " }\n    };\n    pagespeed.addHandler(window, \'scroll\', lazy_on"
    "scroll);\n  }\n};\n\npagespeed[\'lazyLoadInit\'] = pagespeed.lazyL"
    "oadInit;\n";

}  // namespace net_instaweb
