// Copyright 2011 Google Inc. All Rights Reserved.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Automatically generated from ../../net/instaweb/rewriter/local_storage_cache.js

namespace net_instaweb {

const char* JS_local_storage_cache =
    "/*\n * Copyright 2012 Google Inc.\n *\n * Licensed under the Ap"
    "ache License, Version 2.0 (the \"License\");\n * you may not us"
    "e this file except in compliance with the License.\n * You ma"
    "y obtain a copy of the License at\n *\n *      http://www.apac"
    "he.org/licenses/LICENSE-2.0\n *\n * Unless required by applica"
    "ble law or agreed to in writing, software\n * distributed und"
    "er the License is distributed on an \"AS IS\" BASIS,\n * WITHOU"
    "T WARRANTIES OR CONDITIONS OF ANY KIND, either express or im"
    "plied.\n * See the License for the specific language governin"
    "g permissions and\n * limitations under the License.\n */\n\n/**"
    "\n * @fileoverview Code for caching inlined resources in loca"
    "l storage on first\n * view and fetching them therefrom on re"
    "peat view.\n *\n * @author matterbury@google.com (Matt Atterbu"
    "ry)\n */\n\n// Exporting functions using quoted attributes to p"
    "revent js compiler from\n// renaming them.\n// See http://code"
    ".google.com/closure/compiler/docs/api-tutorial3.html#dangers"
    "\nwindow[\'pagespeed\'] = window[\'pagespeed\'] || {};\nvar pagesp"
    "eed = window[\'pagespeed\'];\n\n/**\n * @constructor\n */\npagespee"
    "d.LocalStorageCache = function() {\n  /**\n   * Flag indicatin"
    "g that the cookie needs to be regenerated.\n   * @type {boole"
    "an}\n   * @private\n   */\n  this.regenerate_cookie_ = true;\n};"
    "\n\n/**\n * @return {boolean} True if the given object has expi"
    "red.\n * @param {*} obj is an object of the form \'<expiry> <h"
    "ash> <inline-data>\'.\n */\npagespeed.LocalStorageCache.prototy"
    "pe.hasExpired = function(obj) {\n  var expiry = parseInt(obj."
    "substring(0, obj.indexOf(\' \')), 10);\n  return (!isNaN(expiry"
    ") && expiry <= Date.now());\n};\n\npagespeed.LocalStorageCache."
    "prototype[\'hasExpired\'] =\n    pagespeed.LocalStorageCache.pr"
    "ototype.hasExpired;\n\n/**\n * @return {string} The data part o"
    "f the given object.\n * @param {*} obj is an object of the fo"
    "rm \'<expiry> <hash> <inline-data>\'.\n */\npagespeed.LocalStora"
    "geCache.prototype.getData = function(obj) {\n  var pos1 = obj"
    ".indexOf(\' \');\n  var pos2 = obj.indexOf(\' \', pos1 + 1);\n  re"
    "turn obj.substring(pos2 + 1);\n};\n\npagespeed.LocalStorageCach"
    "e.prototype[\'getData\'] =\n    pagespeed.LocalStorageCache.pro"
    "totype.getData;\n\n/**\n * Replaces the last script element in "
    "the DOM with the given element. The\n * script element was ad"
    "ded by our C++ code, replacing the element that was\n * there"
    ", either an img or a style element. The script itself kicked"
    " off the\n * call to this method to replace itself with the o"
    "riginal img/style element\n * using the inlined data from loc"
    "al storage.\n * @param {Element} newElement The element to re"
    "place with.\n */\npagespeed.LocalStorageCache.prototype.replac"
    "eLastScript = function(newElement) {\n  var scripts = documen"
    "t.getElementsByTagName(\'script\');\n  var lastElement = script"
    "s[scripts.length - 1];\n  lastElement.parentNode.replaceChild"
    "(newElement, lastElement);\n};\n\npagespeed.LocalStorageCache.p"
    "rototype[\'replaceLastScript\'] =\n    pagespeed.LocalStorageCa"
    "che.prototype.replaceLastScript;\n\n/**\n * Inline the CSS with"
    " the given URL.\n * @param {string} url is the URL of the CSS"
    " to inline.\n */\npagespeed.LocalStorageCache.prototype.inline"
    "Css = function(url) {\n  var obj = window.localStorage.getIte"
    "m(\'pagespeed_lsc_url:\' + url);\n  var newNode = document.crea"
    "teElement(obj ? \'style\' : \'link\');\n  if (obj && !this.hasExp"
    "ired(obj)) {\n    newNode.type = \'text/css\';\n    newNode.appe"
    "ndChild(document.createTextNode(this.getData(obj)));\n  } els"
    "e {\n    newNode.rel = \'stylesheet\';\n    newNode.href = url;\n"
    "    this.regenerate_cookie_ = true;\n  }\n  this.replaceLastSc"
    "ript(newNode);\n};\n\npagespeed.LocalStorageCache.prototype[\'in"
    "lineCss\'] =\n    pagespeed.LocalStorageCache.prototype.inline"
    "Css;\n\n/**\n * Inline the IMG with the given URL.\n * @param {s"
    "tring} url is the URL of the image to inline.\n */\npagespeed."
    "LocalStorageCache.prototype.inlineImg = function(url) {\n  va"
    "r obj = window.localStorage.getItem(\'pagespeed_lsc_url:\' + u"
    "rl);\n  var newNode = document.createElement(\'img\');\n  if (ob"
    "j && !this.hasExpired(obj)) {\n    newNode.src = this.getData"
    "(obj);\n  } else {\n    newNode.src = url;\n    this.regenerate"
    "_cookie_ = true;\n  }\n  // Copy over any other original attri"
    "butes.\n  for (var i = 1, n = arguments.length; i < n; ++i) {"
    "\n    var pos = arguments[i].indexOf(\'=\');\n    newNode.setAtt"
    "ribute(arguments[i].substring(0, pos),\n                     "
    "    arguments[i].substring(pos + 1));\n  }\n  this.replaceLast"
    "Script(newNode);\n};\n\npagespeed.LocalStorageCache.prototype[\'"
    "inlineImg\'] =\n    pagespeed.LocalStorageCache.prototype.inli"
    "neImg;\n\n/**\n * For each element of the given tag name, check"
    " if it has a pagespeed_lsc_hash\n * attribute and if so saves"
    " the element\'s hash, expiry, and data local storage.\n * If a"
    "ny elements are saved regenerate_cookie_ is set to true to f"
    "orce\n * regeneration.\n * @param {string} tagName Tag Name of"
    " elements to process.\n * @param {function ({Element})} dataF"
    "unc Function to get an element\'s data.\n * @private\n */\npages"
    "peed.LocalStorageCache.prototype.processTags_ = function(tag"
    "Name,\n                                                      "
    "        dataFunc) {\n  var elements = document.getElementsByT"
    "agName(tagName);\n  for (var i = 0, n = elements.length; i < "
    "n; ++i) {\n    var element = elements[i];\n    var hash = elem"
    "ent.getAttribute(\'pagespeed_lsc_hash\');\n    var url = elemen"
    "t.getAttribute(\'pagespeed_lsc_url\');\n    if (hash && url) {\n"
    "      var urlkey = \'pagespeed_lsc_url:\' + url;\n      var exp"
    "iry = element.getAttribute(\'pagespeed_lsc_expiry\');\n      va"
    "r millis = (expiry ? (new Date(expiry)).getTime() : \'\');\n   "
    "   var data = dataFunc(element);\n      if (!data) {\n        "
    "// img.src is set to a data URI on the repeat view but is mi"
    "ssing\n        // thereafter, and we must not forget it once "
    "we have it.\n        var obj = window.localStorage.getItem(ur"
    "lkey);\n        if (obj) {\n          data = this.getData(obj)"
    ";\n        }\n      }\n      if (data) {\n        window.localSt"
    "orage.setItem(urlkey, millis + \' \' + hash + \' \' + data);\n   "
    "     this.regenerate_cookie_ = true;\n      }\n    }\n  }\n};\n\n/"
    "**\n * Save any inlined data to local storage.\n * @private\n *"
    "/\npagespeed.LocalStorageCache.prototype.saveInlinedData_ = f"
    "unction() {\n  this.processTags_(\'img\', function(e) { return "
    "e.src; });\n  this.processTags_(\'style\',\n                    "
    "function(e) {\n                      return (e.firstChild ? e"
    ".firstChild.nodeValue : null);\n                    });\n};\n\n/"
    "**\n * Regenerate the cookie from the hash\'s of unexpired obj"
    "ects in local storage\n * and remove all expired objects.\n * "
    "@private\n */\npagespeed.LocalStorageCache.prototype.generateC"
    "ookie_ = function() {\n  if (this.regenerate_cookie_) {\n    v"
    "ar deadUns = [];\n    var goodUns = [];\n    var minExpiry = 0"
    ";\n    var currentTime = Date.now();\n    // Process every loc"
    "al storage object of ours.\n    for (var i = 0, n = window.lo"
    "calStorage.length; i < n; ++i) {\n      var key = window.loca"
    "lStorage.key(i);\n      if (key.indexOf(\'pagespeed_lsc_url:\')"
    ") continue;  // Not one of ours.\n      var obj = window.loca"
    "lStorage.getItem(key);\n      var pos1 = obj.indexOf(\' \');\n  "
    "    var expiry = parseInt(obj.substring(0, pos1), 10);\n     "
    " if (!isNaN(expiry)) {\n        if (expiry <= currentTime) {\n"
    "          deadUns.push(key);\n          continue;\n        } e"
    "lse if (expiry < minExpiry || minExpiry == 0) {\n          mi"
    "nExpiry = expiry;\n        }\n      }\n      var pos2 = obj.ind"
    "exOf(\' \', pos1 + 1);\n      var hash = obj.substring(pos1 + 1"
    ", pos2);\n      goodUns.push(hash);\n    }\n    // Set the cook"
    "ie.\n    var expires = \'\';\n    if (minExpiry) expires = \'; ex"
    "pires=\' + (new Date(minExpiry)).toUTCString();\n    document."
    "cookie = \'_GPSLSC=\' + goodUns.join(\'!\') + expires;\n    // Re"
    "move all expired objects.\n    for (var i = 0, n = deadUns.le"
    "ngth; i < n; ++i) {\n      window.localStorage.removeItem(dea"
    "dUns[i]);\n    }\n    this.regenerate_cookie_ = false;\n  }\n};\n"
    "\n/**\n * Runs the function when event is triggered.\n * @param"
    " {Window|Element} elem Element to attach handler.\n * @param "
    "{string} ev Name of the event.\n * @param {function()} func N"
    "ew onload handler.\n *\n * TODO(nikhilmadan): Avoid duplicatio"
    "n with all the other JS code.\n */\npagespeed.addHandler = fun"
    "ction(elem, ev, func) {\n  if (elem.addEventListener) {\n    e"
    "lem.addEventListener(ev, func, false);\n  } else if (elem.att"
    "achEvent) {\n    elem.attachEvent(\'on\' + ev, func);\n  } else "
    "{\n    var oldHandler = elem[\'on\' + ev];\n    elem[\'on\' + ev] "
    "= function() {\n      func.call(this);\n      if (oldHandler) "
    "{\n        oldHandler.call(this);\n      }\n    };\n  }\n};\n\n/**\n"
    " * Initializes the local storage cache module.\n */\npagespeed"
    ".localStorageCacheInit = function() {\n  // Do nothing if any"
    " required API is missing.\n  if (window.localStorage) {\n    v"
    "ar temp = new pagespeed.LocalStorageCache();\n    pagespeed[\'"
    "localStorageCache\'] = temp;\n    pagespeed.addHandler(window,"
    " \'load\',\n                         function() {\n             "
    "              temp.saveInlinedData_();\n                     "
    "    });\n    pagespeed.addHandler(window, \'load\',\n           "
    "              function() {\n                           temp.g"
    "enerateCookie_();\n                         });\n  }\n};\n\npages"
    "peed[\'localStorageCacheInit\'] = pagespeed.localStorageCacheI"
    "nit;\n";

}  // namespace net_instaweb
